import { __decorate, __metadata } from 'tslib';
import { randomUUID } from 'crypto';
import { z } from 'zod';
import { createAmazonBedrock } from '@ai-sdk/amazon-bedrock';
import { createAnthropic } from '@ai-sdk/anthropic';
import { createAzure } from '@ai-sdk/azure';
import { createCohere } from '@ai-sdk/cohere';
import { createGoogleGenerativeAI } from '@ai-sdk/google';
import { createMistral } from '@ai-sdk/mistral';
import { createOpenAI } from '@ai-sdk/openai';
import { createXai } from '@ai-sdk/xai';
import { embed, embedMany, tool, generateText, generateObject, streamText, streamObject } from 'ai';
import { createAnthropicVertex } from 'anthropic-vertex-ai';
import { Redis } from '@upstash/redis';
import { existsSync, mkdirSync, readFileSync, writeFileSync } from 'fs';
import path from 'path';
import { trace, context, SpanStatusCode, SpanKind } from '@opentelemetry/api';
import { getNodeAutoInstrumentations } from '@opentelemetry/auto-instrumentations-node';
import { OTLPTraceExporter } from '@opentelemetry/exporter-trace-otlp-http';
import { Resource } from '@opentelemetry/resources';
import { NodeSDK } from '@opentelemetry/sdk-node';
import { AlwaysOnSampler, TraceIdRatioBasedSampler, ParentBasedSampler, AlwaysOffSampler, ConsoleSpanExporter } from '@opentelemetry/sdk-trace-base';
import { ATTR_SERVICE_NAME } from '@opentelemetry/semantic-conventions';
import { get } from 'radash';
import sift from 'sift';
import { setup, assign, fromPromise, createActor } from 'xstate';

function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
function asyncGeneratorStep(n, t, e, r, o, a, c) {
  try {
    var i = n[a](c),
      u = i.value;
  } catch (n) {
    return void e(n);
  }
  i.done ? t(u) : Promise.resolve(u).then(r, o);
}
function _asyncToGenerator(n) {
  return function () {
    var t = this,
      e = arguments;
    return new Promise(function (r, o) {
      var a = n.apply(t, e);
      function _next(n) {
        asyncGeneratorStep(a, r, o, _next, _throw, "next", n);
      }
      function _throw(n) {
        asyncGeneratorStep(a, r, o, _next, _throw, "throw", n);
      }
      _next(void 0);
    });
  };
}
function _classPrivateFieldLooseBase(e, t) {
  if (!{}.hasOwnProperty.call(e, t)) throw new TypeError("attempted to use private field on non-instance");
  return e;
}
var id = 0;
function _classPrivateFieldLooseKey(e) {
  return "__private_" + id++ + "_" + e;
}
function _defineProperties(e, r) {
  for (var t = 0; t < r.length; t++) {
    var o = r[t];
    o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o);
  }
}
function _createClass(e, r, t) {
  return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", {
    writable: !1
  }), e;
}
function _createForOfIteratorHelperLoose(r, e) {
  var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (t) return (t = t.call(r)).next.bind(t);
  if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) {
    t && (r = t);
    var o = 0;
    return function () {
      return o >= r.length ? {
        done: !0
      } : {
        done: !1,
        value: r[o++]
      };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function (n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
function _inheritsLoose(t, o) {
  t.prototype = Object.create(o.prototype), t.prototype.constructor = t, _setPrototypeOf(t, o);
}
function _objectWithoutPropertiesLoose(r, e) {
  if (null == r) return {};
  var t = {};
  for (var n in r) if ({}.hasOwnProperty.call(r, n)) {
    if (e.includes(n)) continue;
    t[n] = r[n];
  }
  return t;
}
function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return e;
  };
  var t,
    e = {},
    r = Object.prototype,
    n = r.hasOwnProperty,
    o = Object.defineProperty || function (t, e, r) {
      t[e] = r.value;
    },
    i = "function" == typeof Symbol ? Symbol : {},
    a = i.iterator || "@@iterator",
    c = i.asyncIterator || "@@asyncIterator",
    u = i.toStringTag || "@@toStringTag";
  function define(t, e, r) {
    return Object.defineProperty(t, e, {
      value: r,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), t[e];
  }
  try {
    define({}, "");
  } catch (t) {
    define = function (t, e, r) {
      return t[e] = r;
    };
  }
  function wrap(t, e, r, n) {
    var i = e && e.prototype instanceof Generator ? e : Generator,
      a = Object.create(i.prototype),
      c = new Context(n || []);
    return o(a, "_invoke", {
      value: makeInvokeMethod(t, r, c)
    }), a;
  }
  function tryCatch(t, e, r) {
    try {
      return {
        type: "normal",
        arg: t.call(e, r)
      };
    } catch (t) {
      return {
        type: "throw",
        arg: t
      };
    }
  }
  e.wrap = wrap;
  var h = "suspendedStart",
    l = "suspendedYield",
    f = "executing",
    s = "completed",
    y = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var p = {};
  define(p, a, function () {
    return this;
  });
  var d = Object.getPrototypeOf,
    v = d && d(d(values([])));
  v && v !== r && n.call(v, a) && (p = v);
  var g = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(p);
  function defineIteratorMethods(t) {
    ["next", "throw", "return"].forEach(function (e) {
      define(t, e, function (t) {
        return this._invoke(e, t);
      });
    });
  }
  function AsyncIterator(t, e) {
    function invoke(r, o, i, a) {
      var c = tryCatch(t[r], t, o);
      if ("throw" !== c.type) {
        var u = c.arg,
          h = u.value;
        return h && "object" == typeof h && n.call(h, "__await") ? e.resolve(h.__await).then(function (t) {
          invoke("next", t, i, a);
        }, function (t) {
          invoke("throw", t, i, a);
        }) : e.resolve(h).then(function (t) {
          u.value = t, i(u);
        }, function (t) {
          return invoke("throw", t, i, a);
        });
      }
      a(c.arg);
    }
    var r;
    o(this, "_invoke", {
      value: function (t, n) {
        function callInvokeWithMethodAndArg() {
          return new e(function (e, r) {
            invoke(t, n, e, r);
          });
        }
        return r = r ? r.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(e, r, n) {
    var o = h;
    return function (i, a) {
      if (o === f) throw Error("Generator is already running");
      if (o === s) {
        if ("throw" === i) throw a;
        return {
          value: t,
          done: !0
        };
      }
      for (n.method = i, n.arg = a;;) {
        var c = n.delegate;
        if (c) {
          var u = maybeInvokeDelegate(c, n);
          if (u) {
            if (u === y) continue;
            return u;
          }
        }
        if ("next" === n.method) n.sent = n._sent = n.arg;else if ("throw" === n.method) {
          if (o === h) throw o = s, n.arg;
          n.dispatchException(n.arg);
        } else "return" === n.method && n.abrupt("return", n.arg);
        o = f;
        var p = tryCatch(e, r, n);
        if ("normal" === p.type) {
          if (o = n.done ? s : l, p.arg === y) continue;
          return {
            value: p.arg,
            done: n.done
          };
        }
        "throw" === p.type && (o = s, n.method = "throw", n.arg = p.arg);
      }
    };
  }
  function maybeInvokeDelegate(e, r) {
    var n = r.method,
      o = e.iterator[n];
    if (o === t) return r.delegate = null, "throw" === n && e.iterator.return && (r.method = "return", r.arg = t, maybeInvokeDelegate(e, r), "throw" === r.method) || "return" !== n && (r.method = "throw", r.arg = new TypeError("The iterator does not provide a '" + n + "' method")), y;
    var i = tryCatch(o, e.iterator, r.arg);
    if ("throw" === i.type) return r.method = "throw", r.arg = i.arg, r.delegate = null, y;
    var a = i.arg;
    return a ? a.done ? (r[e.resultName] = a.value, r.next = e.nextLoc, "return" !== r.method && (r.method = "next", r.arg = t), r.delegate = null, y) : a : (r.method = "throw", r.arg = new TypeError("iterator result is not an object"), r.delegate = null, y);
  }
  function pushTryEntry(t) {
    var e = {
      tryLoc: t[0]
    };
    1 in t && (e.catchLoc = t[1]), 2 in t && (e.finallyLoc = t[2], e.afterLoc = t[3]), this.tryEntries.push(e);
  }
  function resetTryEntry(t) {
    var e = t.completion || {};
    e.type = "normal", delete e.arg, t.completion = e;
  }
  function Context(t) {
    this.tryEntries = [{
      tryLoc: "root"
    }], t.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(e) {
    if (e || "" === e) {
      var r = e[a];
      if (r) return r.call(e);
      if ("function" == typeof e.next) return e;
      if (!isNaN(e.length)) {
        var o = -1,
          i = function next() {
            for (; ++o < e.length;) if (n.call(e, o)) return next.value = e[o], next.done = !1, next;
            return next.value = t, next.done = !0, next;
          };
        return i.next = i;
      }
    }
    throw new TypeError(typeof e + " is not iterable");
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, o(g, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), o(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, u, "GeneratorFunction"), e.isGeneratorFunction = function (t) {
    var e = "function" == typeof t && t.constructor;
    return !!e && (e === GeneratorFunction || "GeneratorFunction" === (e.displayName || e.name));
  }, e.mark = function (t) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(t, GeneratorFunctionPrototype) : (t.__proto__ = GeneratorFunctionPrototype, define(t, u, "GeneratorFunction")), t.prototype = Object.create(g), t;
  }, e.awrap = function (t) {
    return {
      __await: t
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, c, function () {
    return this;
  }), e.AsyncIterator = AsyncIterator, e.async = function (t, r, n, o, i) {
    void 0 === i && (i = Promise);
    var a = new AsyncIterator(wrap(t, r, n, o), i);
    return e.isGeneratorFunction(r) ? a : a.next().then(function (t) {
      return t.done ? t.value : a.next();
    });
  }, defineIteratorMethods(g), define(g, u, "Generator"), define(g, a, function () {
    return this;
  }), define(g, "toString", function () {
    return "[object Generator]";
  }), e.keys = function (t) {
    var e = Object(t),
      r = [];
    for (var n in e) r.push(n);
    return r.reverse(), function next() {
      for (; r.length;) {
        var t = r.pop();
        if (t in e) return next.value = t, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, e.values = values, Context.prototype = {
    constructor: Context,
    reset: function (e) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = t, this.done = !1, this.delegate = null, this.method = "next", this.arg = t, this.tryEntries.forEach(resetTryEntry), !e) for (var r in this) "t" === r.charAt(0) && n.call(this, r) && !isNaN(+r.slice(1)) && (this[r] = t);
    },
    stop: function () {
      this.done = !0;
      var t = this.tryEntries[0].completion;
      if ("throw" === t.type) throw t.arg;
      return this.rval;
    },
    dispatchException: function (e) {
      if (this.done) throw e;
      var r = this;
      function handle(n, o) {
        return a.type = "throw", a.arg = e, r.next = n, o && (r.method = "next", r.arg = t), !!o;
      }
      for (var o = this.tryEntries.length - 1; o >= 0; --o) {
        var i = this.tryEntries[o],
          a = i.completion;
        if ("root" === i.tryLoc) return handle("end");
        if (i.tryLoc <= this.prev) {
          var c = n.call(i, "catchLoc"),
            u = n.call(i, "finallyLoc");
          if (c && u) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          } else if (c) {
            if (this.prev < i.catchLoc) return handle(i.catchLoc, !0);
          } else {
            if (!u) throw Error("try statement without catch or finally");
            if (this.prev < i.finallyLoc) return handle(i.finallyLoc);
          }
        }
      }
    },
    abrupt: function (t, e) {
      for (var r = this.tryEntries.length - 1; r >= 0; --r) {
        var o = this.tryEntries[r];
        if (o.tryLoc <= this.prev && n.call(o, "finallyLoc") && this.prev < o.finallyLoc) {
          var i = o;
          break;
        }
      }
      i && ("break" === t || "continue" === t) && i.tryLoc <= e && e <= i.finallyLoc && (i = null);
      var a = i ? i.completion : {};
      return a.type = t, a.arg = e, i ? (this.method = "next", this.next = i.finallyLoc, y) : this.complete(a);
    },
    complete: function (t, e) {
      if ("throw" === t.type) throw t.arg;
      return "break" === t.type || "continue" === t.type ? this.next = t.arg : "return" === t.type ? (this.rval = this.arg = t.arg, this.method = "return", this.next = "end") : "normal" === t.type && e && (this.next = e), y;
    },
    finish: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.finallyLoc === t) return this.complete(r.completion, r.afterLoc), resetTryEntry(r), y;
      }
    },
    catch: function (t) {
      for (var e = this.tryEntries.length - 1; e >= 0; --e) {
        var r = this.tryEntries[e];
        if (r.tryLoc === t) {
          var n = r.completion;
          if ("throw" === n.type) {
            var o = n.arg;
            resetTryEntry(r);
          }
          return o;
        }
      }
      throw Error("illegal catch attempt");
    },
    delegateYield: function (e, r, n) {
      return this.delegate = {
        iterator: values(e),
        resultName: r,
        nextLoc: n
      }, "next" === this.method && (this.arg = t), y;
    }
  }, e;
}
function _setPrototypeOf(t, e) {
  return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) {
    return t.__proto__ = e, t;
  }, _setPrototypeOf(t, e);
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r || "default");
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return ("string" === r ? String : Number)(t);
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}

// Constants and Types
var RegisteredLogger = {
  AGENT: 'AGENT',
  WORKFLOW: 'WORKFLOW',
  LLM: 'LLM'
};
var LogLevel = {
  DEBUG: 'DEBUG',
  INFO: 'INFO',
  WARN: 'WARN',
  ERROR: 'ERROR'
};
// Abstract Base Logger
var BaseLogger = /*#__PURE__*/function () {
  function BaseLogger(level) {
    if (level === void 0) {
      level = LogLevel.INFO;
    }
    this.level = void 0;
    this.level = level;
  }
  var _proto = BaseLogger.prototype;
  _proto.debug = function debug(message) {
    if (this.level <= LogLevel.DEBUG) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }
      return this.log.apply(this, [LogLevel.DEBUG, message].concat(args));
    }
  };
  _proto.info = function info(message) {
    if (this.level <= LogLevel.INFO) {
      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }
      return this.log.apply(this, [LogLevel.INFO, message].concat(args));
    }
  };
  _proto.warn = function warn(message) {
    if (this.level <= LogLevel.WARN) {
      for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
        args[_key3 - 1] = arguments[_key3];
      }
      return this.log.apply(this, [LogLevel.WARN, message].concat(args));
    }
  };
  _proto.error = function error(message) {
    if (this.level <= LogLevel.ERROR) {
      for (var _len4 = arguments.length, args = new Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
        args[_key4 - 1] = arguments[_key4];
      }
      return this.log.apply(this, [LogLevel.ERROR, message].concat(args));
    }
  };
  _proto.formatMessage = function formatMessage(message) {
    if (typeof message === 'string') {
      return message;
    }
    return JSON.stringify(message);
  };
  _proto.formatLogEntry = function formatLogEntry(level, message) {
    return {
      timestamp: new Date().toISOString(),
      level: LogLevel[level],
      message: this.formatMessage(message)
    };
  };
  _proto.getLogsByRunId = /*#__PURE__*/function () {
    var _getLogsByRunId = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(runId) {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            console.warn("getLogsByRunId " + runId + " not implemented for " + this.constructor.name);
            return _context.abrupt("return", []);
          case 2:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function getLogsByRunId(_x) {
      return _getLogsByRunId.apply(this, arguments);
    }
    return getLogsByRunId;
  }();
  return BaseLogger;
}();
// Console Logger Implementation
var ConsoleLogger = /*#__PURE__*/function (_BaseLogger2) {
  function ConsoleLogger(level) {
    return _BaseLogger2.call(this, level != null ? level : LogLevel.INFO) || this;
  }
  _inheritsLoose(ConsoleLogger, _BaseLogger2);
  var _proto2 = ConsoleLogger.prototype;
  _proto2.log = function log(level, message) {
    var _console;
    var logEntry = this.formatLogEntry(level, message);
    for (var _len5 = arguments.length, args = new Array(_len5 > 2 ? _len5 - 2 : 0), _key5 = 2; _key5 < _len5; _key5++) {
      args[_key5 - 2] = arguments[_key5];
    }
    (_console = console).log.apply(_console, ["[" + logEntry.timestamp + "] [" + logEntry.level + "] " + logEntry.message].concat(args));
  };
  return ConsoleLogger;
}(BaseLogger);
// File Logger Implementation
var _dirPath = /*#__PURE__*/_classPrivateFieldLooseKey("dirPath");
var FileLogger = /*#__PURE__*/function (_BaseLogger3) {
  function FileLogger(dirPath, level) {
    var _this;
    if (dirPath === void 0) {
      dirPath = 'logs';
    }
    _this = _BaseLogger3.call(this, level != null ? level : LogLevel.INFO) || this;
    Object.defineProperty(_this, _dirPath, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldLooseBase(_this, _dirPath)[_dirPath] = dirPath;
    return _this;
  }
  _inheritsLoose(FileLogger, _BaseLogger3);
  var _proto3 = FileLogger.prototype;
  _proto3.log = function log(level, message) {
    if (typeof message === 'string') {
      throw new Error('FileLogger requires a BaseLogMessage object');
    }
    var fullPath = path.join(_classPrivateFieldLooseBase(this, _dirPath)[_dirPath], message.destinationPath + ".json");
    this.ensureDirectoryExists();
    this.writeLogToFile(fullPath, level, message);
  };
  _proto3.ensureDirectoryExists = function ensureDirectoryExists() {
    if (!existsSync(_classPrivateFieldLooseBase(this, _dirPath)[_dirPath])) {
      mkdirSync(_classPrivateFieldLooseBase(this, _dirPath)[_dirPath], {
        recursive: true
      });
    }
  };
  _proto3.writeLogToFile = function writeLogToFile(fullPath, level, message) {
    var logEntry = _extends({}, message, {
      level: LogLevel[level],
      createdAt: new Date()
    });
    var logs = [];
    if (existsSync(fullPath)) {
      logs = JSON.parse(readFileSync(fullPath, 'utf-8'));
    }
    logs.push(logEntry);
    writeFileSync(fullPath, JSON.stringify(logs, null, 2));
  };
  return FileLogger;
}(BaseLogger);
// Upstash Redis Logger Implementation
var _redis = /*#__PURE__*/_classPrivateFieldLooseKey("redis");
var _key6 = /*#__PURE__*/_classPrivateFieldLooseKey("key");
var UpstashRedisLogger = /*#__PURE__*/function (_BaseLogger4) {
  function UpstashRedisLogger(redis, key, level) {
    var _this2;
    if (key === void 0) {
      key = 'logs';
    }
    _this2 = _BaseLogger4.call(this, level != null ? level : LogLevel.INFO) || this;
    Object.defineProperty(_this2, _redis, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(_this2, _key6, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldLooseBase(_this2, _redis)[_redis] = redis;
    _classPrivateFieldLooseBase(_this2, _key6)[_key6] = key;
    return _this2;
  }
  _inheritsLoose(UpstashRedisLogger, _BaseLogger4);
  var _proto4 = UpstashRedisLogger.prototype;
  _proto4.log = /*#__PURE__*/function () {
    var _log = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(level, message) {
      var logEntry, runKey;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            if (!(typeof message === 'string')) {
              _context2.next = 2;
              break;
            }
            throw new Error('UpstashRedisLogger requires a BaseLogMessage object');
          case 2:
            logEntry = _extends({}, message, {
              level: LogLevel[level],
              createdAt: new Date(),
              runId: message.runId
            });
            runKey = _classPrivateFieldLooseBase(this, _key6)[_key6] + ":run:" + message.runId;
            if (!message.runId) {
              _context2.next = 9;
              break;
            }
            _context2.next = 7;
            return Promise.all([_classPrivateFieldLooseBase(this, _redis)[_redis].lpush(_classPrivateFieldLooseBase(this, _key6)[_key6], JSON.stringify(logEntry)), _classPrivateFieldLooseBase(this, _redis)[_redis].lpush(runKey, JSON.stringify(logEntry))]);
          case 7:
            _context2.next = 11;
            break;
          case 9:
            _context2.next = 11;
            return _classPrivateFieldLooseBase(this, _redis)[_redis].lpush(_classPrivateFieldLooseBase(this, _key6)[_key6], JSON.stringify(logEntry));
          case 11:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function log(_x2, _x3) {
      return _log.apply(this, arguments);
    }
    return log;
  }();
  _proto4.getLogs = /*#__PURE__*/function () {
    var _getLogs = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            return _context3.abrupt("return", _classPrivateFieldLooseBase(this, _redis)[_redis].lrange(_classPrivateFieldLooseBase(this, _key6)[_key6], 0, -1));
          case 1:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this);
    }));
    function getLogs() {
      return _getLogs.apply(this, arguments);
    }
    return getLogs;
  }();
  _proto4.getLogsByRunId = /*#__PURE__*/function () {
    var _getLogsByRunId2 = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee4(runId) {
      var runKey, logs;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            if (runId) {
              _context4.next = 2;
              break;
            }
            throw new Error('runId is required');
          case 2:
            _context4.prev = 2;
            runKey = _classPrivateFieldLooseBase(this, _key6)[_key6] + ":run:" + runId;
            _context4.next = 6;
            return _classPrivateFieldLooseBase(this, _redis)[_redis].lrange(runKey, 0, -1);
          case 6:
            logs = _context4.sent;
            return _context4.abrupt("return", logs.reduce(function (acc, logStr) {
              try {
                var log = typeof logStr === 'string' ? JSON.parse(logStr) : logStr;
                if (log && typeof log === 'object' && log.runId === runId) {
                  acc.push(log);
                }
              } catch (parseError) {
                if (typeof logStr === 'string') {
                  console.error("Failed to parse log entry: " + logStr, parseError);
                }
              }
              return acc;
            }, []));
          case 10:
            _context4.prev = 10;
            _context4.t0 = _context4["catch"](2);
            console.error("Failed to fetch logs for runId " + runId + ":", _context4.t0);
            return _context4.abrupt("return", []);
          case 14:
          case "end":
            return _context4.stop();
        }
      }, _callee4, this, [[2, 10]]);
    }));
    function getLogsByRunId(_x4) {
      return _getLogsByRunId2.apply(this, arguments);
    }
    return getLogsByRunId;
  }();
  _proto4.cleanup = /*#__PURE__*/function () {
    var _cleanup = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee5() {
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
          case "end":
            return _context5.stop();
        }
      }, _callee5);
    }));
    function cleanup() {
      return _cleanup.apply(this, arguments);
    }
    return cleanup;
  }();
  return UpstashRedisLogger;
}(BaseLogger);
// Multi Logger Implementation
var MultiLogger = /*#__PURE__*/function () {
  function MultiLogger(loggers) {
    this.loggers = void 0;
    this.loggers = loggers;
  }
  var _proto5 = MultiLogger.prototype;
  _proto5.debug = /*#__PURE__*/function () {
    var _debug = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee6(message) {
      var _len6,
        args,
        _key7,
        _args6 = arguments;
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            for (_len6 = _args6.length, args = new Array(_len6 > 1 ? _len6 - 1 : 0), _key7 = 1; _key7 < _len6; _key7++) {
              args[_key7 - 1] = _args6[_key7];
            }
            _context6.next = 3;
            return Promise.all(this.loggers.map(function (logger) {
              return logger.debug.apply(logger, [message].concat(args));
            }));
          case 3:
          case "end":
            return _context6.stop();
        }
      }, _callee6, this);
    }));
    function debug(_x5) {
      return _debug.apply(this, arguments);
    }
    return debug;
  }();
  _proto5.info = /*#__PURE__*/function () {
    var _info = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee7(message) {
      var _len7,
        args,
        _key8,
        _args7 = arguments;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) switch (_context7.prev = _context7.next) {
          case 0:
            for (_len7 = _args7.length, args = new Array(_len7 > 1 ? _len7 - 1 : 0), _key8 = 1; _key8 < _len7; _key8++) {
              args[_key8 - 1] = _args7[_key8];
            }
            _context7.next = 3;
            return Promise.all(this.loggers.map(function (logger) {
              return logger.info.apply(logger, [message].concat(args));
            }));
          case 3:
          case "end":
            return _context7.stop();
        }
      }, _callee7, this);
    }));
    function info(_x6) {
      return _info.apply(this, arguments);
    }
    return info;
  }();
  _proto5.warn = /*#__PURE__*/function () {
    var _warn = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee8(message) {
      var _len8,
        args,
        _key9,
        _args8 = arguments;
      return _regeneratorRuntime().wrap(function _callee8$(_context8) {
        while (1) switch (_context8.prev = _context8.next) {
          case 0:
            for (_len8 = _args8.length, args = new Array(_len8 > 1 ? _len8 - 1 : 0), _key9 = 1; _key9 < _len8; _key9++) {
              args[_key9 - 1] = _args8[_key9];
            }
            _context8.next = 3;
            return Promise.all(this.loggers.map(function (logger) {
              return logger.warn.apply(logger, [message].concat(args));
            }));
          case 3:
          case "end":
            return _context8.stop();
        }
      }, _callee8, this);
    }));
    function warn(_x7) {
      return _warn.apply(this, arguments);
    }
    return warn;
  }();
  _proto5.error = /*#__PURE__*/function () {
    var _error = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee9(message) {
      var _len9,
        args,
        _key10,
        _args9 = arguments;
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) switch (_context9.prev = _context9.next) {
          case 0:
            for (_len9 = _args9.length, args = new Array(_len9 > 1 ? _len9 - 1 : 0), _key10 = 1; _key10 < _len9; _key10++) {
              args[_key10 - 1] = _args9[_key10];
            }
            _context9.next = 3;
            return Promise.all(this.loggers.map(function (logger) {
              return logger.error.apply(logger, [message].concat(args));
            }));
          case 3:
          case "end":
            return _context9.stop();
        }
      }, _callee9, this);
    }));
    function error(_x8) {
      return _error.apply(this, arguments);
    }
    return error;
  }();
  _proto5.cleanup = /*#__PURE__*/function () {
    var _cleanup2 = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee11() {
      return _regeneratorRuntime().wrap(function _callee11$(_context11) {
        while (1) switch (_context11.prev = _context11.next) {
          case 0:
            _context11.next = 2;
            return Promise.all(this.loggers.map(/*#__PURE__*/function () {
              var _ref = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee10(logger) {
                return _regeneratorRuntime().wrap(function _callee10$(_context10) {
                  while (1) switch (_context10.prev = _context10.next) {
                    case 0:
                      if (!logger.cleanup) {
                        _context10.next = 3;
                        break;
                      }
                      _context10.next = 3;
                      return logger.cleanup();
                    case 3:
                    case "end":
                      return _context10.stop();
                  }
                }, _callee10);
              }));
              return function (_x9) {
                return _ref.apply(this, arguments);
              };
            }()));
          case 2:
          case "end":
            return _context11.stop();
        }
      }, _callee11, this);
    }));
    function cleanup() {
      return _cleanup2.apply(this, arguments);
    }
    return cleanup;
  }();
  return MultiLogger;
}();
// Factory function for built-in loggers
// In createLogger function
var createLogger = function createLogger(config) {
  switch (config.type) {
    case 'CONSOLE':
      return new ConsoleLogger(config.level);
    case 'FILE':
      {
        var fileConfig = config;
        return new FileLogger(fileConfig.dirPath, fileConfig.level);
      }
    case 'UPSTASH':
      {
        var upstashConfig = config;
        var redis = new Redis({
          url: upstashConfig.url,
          token: upstashConfig.token
        });
        return new UpstashRedisLogger(redis, upstashConfig.key, upstashConfig.level);
      }
    default:
      {
        var exhaustiveCheck = config.type;
        throw new Error("Unsupported logger type: " + exhaustiveCheck);
      }
  }
};
function createMultiLogger(loggers) {
  return new MultiLogger(loggers);
}

// Helper function to check if telemetry is active
function hasActiveTelemetry() {
  try {
    return !!trace.getTracer('default-tracer');
  } catch (_unused) {
    return false;
  }
}

// Decorator factory that takes optional spanName
function withSpan(options) {
  return function (_target, propertyKey, descriptor) {
    if (!descriptor || typeof descriptor === 'number') return;
    var originalMethod = descriptor.value;
    var methodName = String(propertyKey);
    descriptor.value = function () {
      var _this = this;
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      // Skip if no telemetry is available and skipIfNoTelemetry is true
      if (options != null && options.skipIfNoTelemetry && !hasActiveTelemetry()) {
        return originalMethod.apply(this, args);
      }
      var tracer = trace.getTracer('default-tracer');
      // Determine span name and kind
      var spanName;
      var spanKind;
      if (typeof options === 'string') {
        spanName = options;
      } else if (options) {
        spanName = options.spanName || methodName;
        spanKind = options.spanKind;
      } else {
        spanName = methodName;
      }
      // Start the span with optional kind
      var span = tracer.startSpan(spanName, {
        kind: spanKind
      });
      var ctx = trace.setSpan(context.active(), span);
      // Record input arguments as span attributes
      args.forEach(function (arg, index) {
        try {
          span.setAttribute(spanName + ".argument." + index, JSON.stringify(arg));
        } catch (e) {
          span.setAttribute(spanName + ".argument." + index, '[Not Serializable]');
        }
      });
      var result;
      try {
        // Call the original method within the context
        result = context["with"](ctx, function () {
          return originalMethod.apply(_this, args);
        });
        // Handle promises
        if (result instanceof Promise) {
          return result.then(function (resolvedValue) {
            try {
              span.setAttribute(spanName + ".result", JSON.stringify(resolvedValue));
            } catch (e) {
              span.setAttribute(spanName + ".result", '[Not Serializable]');
            }
            return resolvedValue;
          })["finally"](function () {
            return span.end();
          });
        }
        // Record result for non-promise returns
        try {
          span.setAttribute(spanName + ".result", JSON.stringify(result));
        } catch (e) {
          span.setAttribute(spanName + ".result", '[Not Serializable]');
        }
        // Return regular results
        return result;
      } catch (error) {
        span.setStatus({
          code: SpanStatusCode.ERROR,
          message: error instanceof Error ? error.message : 'Unknown error'
        });
        if (error instanceof Error) {
          span.recordException(error);
        }
        throw error;
      } finally {
        // End span for non-promise returns
        if (!(result instanceof Promise)) {
          span.end();
        }
      }
    };
    return descriptor;
  };
}
// class-telemetry.decorator.ts
function InstrumentClass(options) {
  return function (target) {
    var methods = Object.getOwnPropertyNames(target.prototype);
    methods.forEach(function (method) {
      var _options$excludeMetho;
      // Skip excluded methods
      if (options != null && (_options$excludeMetho = options.excludeMethods) != null && _options$excludeMetho.includes(method) || method === 'constructor') return;
      // Apply method filter if provided
      if (options != null && options.methodFilter && !options.methodFilter(method)) return;
      var descriptor = Object.getOwnPropertyDescriptor(target.prototype, method);
      if (descriptor && typeof descriptor.value === 'function') {
        Object.defineProperty(target.prototype, method, withSpan({
          spanName: options != null && options.prefix ? options.prefix + "." + method : method,
          skipIfNoTelemetry: true,
          spanKind: (options == null ? void 0 : options.spanKind) || SpanKind.INTERNAL
        })(target, method, descriptor));
      }
    });
    return target;
  };
}

var delay = function delay(ms) {
  return new Promise(function (resolve) {
    return setTimeout(resolve, ms);
  });
};

var _model, _tools$1, _logger$2, _telemetry$4, _log$2;
var LLM = (_model = /*#__PURE__*/_classPrivateFieldLooseKey("model"), _tools$1 = /*#__PURE__*/_classPrivateFieldLooseKey("tools"), _logger$2 = /*#__PURE__*/_classPrivateFieldLooseKey("logger"), _telemetry$4 = /*#__PURE__*/_classPrivateFieldLooseKey("telemetry"), _log$2 = /*#__PURE__*/_classPrivateFieldLooseKey("log"), /*#__PURE__*/function () {
  function LLM(_ref) {
    var model = _ref.model;
    /**
     * Internal logging helper that formats and sends logs to the configured logger
     * @param level - Severity level of the log
     * @param message - Main log message
     * @param runId - Optional runId for the log
     */
    Object.defineProperty(this, _log$2, {
      value: _log2$2
    });
    Object.defineProperty(this, _model, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _tools$1, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _logger$2, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _telemetry$4, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldLooseBase(this, _model)[_model] = model;
    _classPrivateFieldLooseBase(this, _tools$1)[_tools$1] = {};
    _classPrivateFieldLooseBase(this, _logger$2)[_logger$2] = createLogger({
      type: 'CONSOLE'
    });
  }
  var _proto = LLM.prototype;
  /**
   * Set the concrete tools for the agent
   * @param tools
   */
  _proto.__setTools = function __setTools(tools) {
    _classPrivateFieldLooseBase(this, _tools$1)[_tools$1] = tools;
    _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Tools set for LLM");
  }
  /**
   * Set the logger for the agent
   * @param logger
   */;
  _proto.__setLogger = function __setLogger(logger) {
    _classPrivateFieldLooseBase(this, _logger$2)[_logger$2] = logger;
    _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Logger updated for LLM ");
  }
  /**
   * Set the telemetry for the agent
   * @param telemetry
   */;
  _proto.__setTelemetry = function __setTelemetry(telemetry) {
    _classPrivateFieldLooseBase(this, _telemetry$4)[_telemetry$4] = telemetry;
    _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Telemetry updated for LLM " + _classPrivateFieldLooseBase(this, _telemetry$4)[_telemetry$4].tracer);
  }
  /*
  get experimental_telemetry config
  */;
  _proto.getModelType = function getModelType() {
    var _providerToType$model;
    var model = _classPrivateFieldLooseBase(this, _model)[_model];
    if (!('provider' in model)) {
      throw new Error('Model provider is required');
    }
    var providerToType = {
      OPEN_AI: 'openai',
      ANTHROPIC: 'anthropic',
      GROQ: 'groq',
      PERPLEXITY: 'perplexity',
      FIREWORKS: 'fireworks',
      TOGETHER_AI: 'togetherai',
      LM_STUDIO: 'lmstuido',
      BASETEN: 'baseten',
      GOOGLE: 'google',
      MISTRAL: 'mistral',
      X_GROK: 'grok',
      COHERE: 'cohere',
      AZURE: 'azure',
      AMAZON: 'amazon',
      //
      ANTHROPIC_VERTEX: 'anthropic-vertex'
    };
    var type = (_providerToType$model = providerToType[model.provider]) != null ? _providerToType$model : model.provider;
    _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Model type resolved to " + type + " for provider " + model.provider);
    return type;
  };
  _proto.createOpenAICompatibleModel = function createOpenAICompatibleModel(_ref2) {
    var baseURL = _ref2.baseURL,
      apiKey = _ref2.apiKey,
      defaultModelName = _ref2.defaultModelName,
      modelName = _ref2.modelName,
      fetch = _ref2.fetch;
    _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Creating OpenAI compatible model with baseURL: " + baseURL);
    var client = createOpenAI({
      baseURL: baseURL,
      apiKey: apiKey,
      fetch: fetch
    });
    return client(modelName || defaultModelName);
  };
  _proto.createModelDef = function createModelDef(_ref3) {
    var model = _ref3.model;
    var modelDef;
    if (model.type === 'openai') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing OpenAI model " + (model.name || 'gpt-4o-2024-08-06'));
      var openai = createOpenAI({
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.OPENAI_API_KEY
      });
      modelDef = openai(model.name || 'gpt-4o-2024-08-06', {
        structuredOutputs: true
      });
    } else if (model.type === 'anthropic') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Anthropic model " + (model.name || 'claude-3-5-sonnet-20240620'));
      var anthropic = createAnthropic({
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.ANTHROPIC_API_KEY
      });
      modelDef = anthropic(model.name || 'claude-3-5-sonnet-20240620');
    } else if (model.type === 'google') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Google model " + (model.name || 'gemini-1.5-pro-latest'));
      var google = createGoogleGenerativeAI({
        baseURL: 'https://generativelanguage.googleapis.com/v1beta',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.GOOGLE_GENERATIVE_AI_API_KEY || ''
      });
      modelDef = google(model.name || 'gemini-1.5-pro-latest');
    } else if (model.type === 'groq') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Groq model " + (model.name || 'llama-3.2-90b-text-preview'));
      modelDef = this.createOpenAICompatibleModel({
        baseURL: 'https://api.groq.com/openai/v1',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.GROQ_API_KEY || '',
        defaultModelName: 'llama-3.2-90b-text-preview',
        modelName: model.name
      });
    } else if (model.type === 'perplexity') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Perplexity model " + (model.name || 'llama-3.1-sonar-large-128k-chat'));
      modelDef = this.createOpenAICompatibleModel({
        baseURL: 'https://api.perplexity.ai/',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.PERPLEXITY_API_KEY || '',
        defaultModelName: 'llama-3.1-sonar-large-128k-chat',
        modelName: model.name
      });
    } else if (model.type === 'fireworks') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Fireworks model " + (model.name || 'llama-v3p1-70b-instruct'));
      modelDef = this.createOpenAICompatibleModel({
        baseURL: 'https://api.fireworks.ai/inference/v1',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.FIREWORKS_API_KEY || '',
        defaultModelName: 'llama-v3p1-70b-instruct',
        modelName: model.name
      });
    } else if (model.type === 'togetherai') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing TogetherAI model " + (model.name || 'google/gemma-2-9b-it'));
      modelDef = this.createOpenAICompatibleModel({
        baseURL: 'https://api.together.xyz/v1/',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.TOGETHER_AI_API_KEY || '',
        defaultModelName: 'google/gemma-2-9b-it',
        modelName: model.name
      });
    } else if (model.type === 'lmstudio') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing LMStudio model " + (model.name || 'llama-3.2-1b'));
      if (!(model != null && model.baseURL)) {
        var error = "LMStudio model requires a baseURL";
        _classPrivateFieldLooseBase(this, _logger$2)[_logger$2].error(error);
        throw new Error(error);
      }
      modelDef = this.createOpenAICompatibleModel({
        baseURL: model.baseURL,
        apiKey: 'not-needed',
        defaultModelName: 'llama-3.2-1b',
        modelName: model.name
      });
    } else if (model.type === 'baseten') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing BaseTen model " + (model.name || 'llama-3.1-70b-instruct'));
      if (model != null && model.fetch) {
        var _error = "Custom fetch is required to use " + model.type + ". see https://docs.baseten.co/api-reference/openai for more information";
        _classPrivateFieldLooseBase(this, _logger$2)[_logger$2].error(_error);
        throw new Error(_error);
      }
      modelDef = this.createOpenAICompatibleModel({
        baseURL: 'https://bridge.baseten.co/v1/direct',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.BASETEN_API_KEY || '',
        defaultModelName: 'llama-3.1-70b-instruct',
        modelName: model.name
      });
    } else if (model.type === 'mistral') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Mistral model " + (model.name || 'pixtral-large-latest'));
      var mistral = createMistral({
        baseURL: 'https://api.mistral.ai/v1',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.MISTRAL_API_KEY || ''
      });
      modelDef = mistral(model.name || 'pixtral-large-latest');
    } else if (model.type === 'grok') {
      var _process$env$XAI_API_;
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing X Grok model " + (model.name || 'grok-beta'));
      var xAi = createXai({
        baseURL: 'https://api.x.ai/v1',
        apiKey: (_process$env$XAI_API_ = process.env.XAI_API_KEY) != null ? _process$env$XAI_API_ : ''
      });
      modelDef = xAi(model.name || 'grok-beta');
    } else if (model.type === 'cohere') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Cohere model " + (model.name || 'command-r-plus'));
      var cohere = createCohere({
        baseURL: 'https://api.cohere.com/v2',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.COHERE_API_KEY || ''
      });
      modelDef = cohere(model.name || 'command-r-plus');
    } else if (model.type === 'azure') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Azure model " + (model.name || 'gpt-35-turbo-instruct'));
      var azure = createAzure({
        resourceName: process.env.AZURE_RESOURCE_NAME || '',
        apiKey: (model == null ? void 0 : model.apiKey) || process.env.AZURE_API_KEY || ''
      });
      modelDef = azure(model.name || 'gpt-35-turbo-instruct');
    } else if (model.type === 'amazon') {
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Amazon model " + (model.name || 'amazon-titan-tg1-large'));
      var amazon = createAmazonBedrock({
        region: process.env.AWS_REGION || '',
        accessKeyId: process.env.AWS_ACCESS_KEY_ID || '',
        secretAccessKey: process.env.AWS_SECRET_ACCESS_KEY || '',
        sessionToken: process.env.AWS_SESSION_TOKEN || ''
      });
      modelDef = amazon(model.name || 'amazon-titan-tg1-large');
    } else if (model.type === 'anthropic-vertex') {
      var _process$env$ANTHROPI;
      _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.INFO, "Initializing Anthropic Vertex model " + (model.name || 'claude-3-5-sonnet@20240620'));
      var anthropicVertex = createAnthropicVertex({
        region: process.env.GOOGLE_VERTEX_REGION,
        projectId: process.env.GOOGLE_VERTEX_PROJECT_ID,
        apiKey: (_process$env$ANTHROPI = process.env.ANTHROPIC_API_KEY) != null ? _process$env$ANTHROPI : ''
      });
      modelDef = anthropicVertex(model.name || 'claude-3-5-sonnet@20240620');
    } else {
      var _error2 = "Invalid model type: " + model.type;
      _classPrivateFieldLooseBase(this, _logger$2)[_logger$2].error(_error2);
      throw new Error(_error2);
    }
    return modelDef;
  };
  _proto.createEmbedding = /*#__PURE__*/function () {
    var _createEmbedding = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref4) {
      var model, value, maxRetries, embeddingModel, openai, cohere;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            model = _ref4.model, value = _ref4.value, maxRetries = _ref4.maxRetries;
            if (!(model.provider === 'OPEN_AI')) {
              _context.next = 6;
              break;
            }
            openai = createOpenAI({
              apiKey: process.env.OPENAI_API_KEY
            });
            embeddingModel = openai.embedding(model.name);
            _context.next = 12;
            break;
          case 6:
            if (!(model.provider === 'COHERE')) {
              _context.next = 11;
              break;
            }
            cohere = createCohere({
              apiKey: process.env.COHERE_API_KEY
            });
            embeddingModel = cohere.embedding(model.name);
            _context.next = 12;
            break;
          case 11:
            throw new Error("Invalid embedding model");
          case 12:
            if (!(value instanceof Array)) {
              _context.next = 16;
              break;
            }
            _context.next = 15;
            return embedMany({
              model: embeddingModel,
              values: value,
              maxRetries: maxRetries
            });
          case 15:
            return _context.abrupt("return", _context.sent);
          case 16:
            _context.next = 18;
            return embed({
              model: embeddingModel,
              value: value,
              maxRetries: maxRetries
            });
          case 18:
            return _context.abrupt("return", _context.sent);
          case 19:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    function createEmbedding(_x) {
      return _createEmbedding.apply(this, arguments);
    }
    return createEmbedding;
  }();
  _proto.getParams = /*#__PURE__*/function () {
    var _getParams = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref5) {
      var tools, resultTool, model, toolsConverted, answerTool, modelDef;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            tools = _ref5.tools, resultTool = _ref5.resultTool, model = _ref5.model;
            toolsConverted = Object.entries(tools).reduce(function (memo, _ref6) {
              var key = _ref6[0],
                val = _ref6[1];
              memo[key] = tool(val);
              return memo;
            }, {});
            answerTool = {};
            if (resultTool) {
              answerTool = {
                answer: tool(resultTool)
              };
            }
            if (!('type' in model)) {
              _context2.next = 8;
              break;
            }
            modelDef = this.createModelDef({
              model: model
            });
            _context2.next = 15;
            break;
          case 8:
            if (!(model.model instanceof Function)) {
              _context2.next = 14;
              break;
            }
            _context2.next = 11;
            return model.model();
          case 11:
            modelDef = _context2.sent;
            _context2.next = 15;
            break;
          case 14:
            modelDef = model.model;
          case 15:
            return _context2.abrupt("return", {
              toolsConverted: toolsConverted,
              modelDef: modelDef,
              answerTool: answerTool,
              toolChoice: model.toolChoice || 'auto'
            });
          case 16:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function getParams(_x2) {
      return _getParams.apply(this, arguments);
    }
    return getParams;
  }();
  _proto.convertTools = function convertTools(enabledTools) {
    var _this = this;
    var converted = Object.entries(enabledTools || {}).reduce(function (memo, value) {
      var k = value[0];
      var enabled = value[1];
      var tool = _classPrivateFieldLooseBase(_this, _tools$1)[_tools$1][k];
      if (enabled && tool) {
        memo[k] = {
          description: tool.description,
          parameters: z.object({
            data: tool.schema
          }),
          execute: tool.executor
        };
      }
      return memo;
    }, {});
    _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Converted tools for LLM");
    return converted;
  };
  _proto.isBaseOutputType = function isBaseOutputType(outputType) {
    return outputType === 'string' || outputType === 'number' || outputType === 'boolean' || outputType === 'date';
  };
  _proto.baseOutputTypeSchema = function baseOutputTypeSchema(outputType) {
    switch (outputType) {
      case 'string':
        return z.string();
      case 'number':
        return z.number();
      case 'boolean':
        return z["boolean"]();
      case 'date':
        return z.string().describe('ISO 8601 date string');
      default:
        return z.string();
    }
  };
  _proto.createOutputSchema = function createOutputSchema(output) {
    var _this2 = this;
    var schema = Object.entries(output).reduce(function (memo, _ref7) {
      var k = _ref7[0],
        v = _ref7[1];
      if (_this2.isBaseOutputType(v.type)) {
        memo[k] = _this2.baseOutputTypeSchema(v.type);
      }
      if (v.type === 'object') {
        var objectItem = v.items;
        var objectItemSchema = _this2.createOutputSchema(objectItem);
        memo[k] = objectItemSchema;
      }
      if (v.type === 'array') {
        var arrayItem = v.items;
        if (_this2.isBaseOutputType(arrayItem.type)) {
          var itemSchema = _this2.baseOutputTypeSchema(arrayItem.type);
          memo[k] = z.array(itemSchema);
        }
        if (arrayItem.type === 'object') {
          var objectInArrayItemSchema = _this2.createOutputSchema(arrayItem.items);
          memo[k] = z.array(objectInArrayItemSchema);
        }
      }
      return memo;
    }, {});
    return z.object(schema);
  };
  _proto.generate = /*#__PURE__*/function () {
    var _generate = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3(messages, _temp) {
      var _ref8, schema, stream, _ref8$maxSteps, maxSteps, onFinish, onStepFinish, enabledTools, convertedTools, runId, msgs;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            _ref8 = _temp === void 0 ? {} : _temp, schema = _ref8.schema, stream = _ref8.stream, _ref8$maxSteps = _ref8.maxSteps, maxSteps = _ref8$maxSteps === void 0 ? 5 : _ref8$maxSteps, onFinish = _ref8.onFinish, onStepFinish = _ref8.onStepFinish, enabledTools = _ref8.enabledTools, convertedTools = _ref8.convertedTools, runId = _ref8.runId;
            if (Array.isArray(messages)) {
              msgs = messages;
            } else {
              msgs = [{
                role: 'user',
                content: messages
              }];
            }
            if (!(stream && schema)) {
              _context3.next = 6;
              break;
            }
            _context3.next = 5;
            return this.__streamObject({
              messages: msgs,
              structuredOutput: schema,
              onStepFinish: onStepFinish,
              onFinish: onFinish,
              maxSteps: maxSteps,
              enabledTools: enabledTools,
              convertedTools: convertedTools,
              runId: runId
            });
          case 5:
            return _context3.abrupt("return", _context3.sent);
          case 6:
            if (!stream) {
              _context3.next = 10;
              break;
            }
            _context3.next = 9;
            return this.__stream({
              messages: msgs,
              onStepFinish: onStepFinish,
              onFinish: onFinish,
              maxSteps: maxSteps,
              enabledTools: enabledTools,
              convertedTools: convertedTools,
              runId: runId
            });
          case 9:
            return _context3.abrupt("return", _context3.sent);
          case 10:
            if (!schema) {
              _context3.next = 14;
              break;
            }
            _context3.next = 13;
            return this.__textObject({
              messages: msgs,
              structuredOutput: schema,
              onStepFinish: onStepFinish,
              maxSteps: maxSteps,
              enabledTools: enabledTools,
              convertedTools: convertedTools,
              runId: runId
            });
          case 13:
            return _context3.abrupt("return", _context3.sent);
          case 14:
            _context3.next = 16;
            return this.__text({
              messages: msgs,
              onStepFinish: onStepFinish,
              maxSteps: maxSteps,
              enabledTools: enabledTools,
              convertedTools: convertedTools,
              runId: runId
            });
          case 16:
            return _context3.abrupt("return", _context3.sent);
          case 17:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this);
    }));
    function generate(_x3, _x4) {
      return _generate.apply(this, arguments);
    }
    return generate;
  }();
  _proto.__text = /*#__PURE__*/function () {
    var _text = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee5(_ref9) {
      var _this3 = this;
      var messages, _onStepFinish, _ref9$maxSteps, maxSteps, enabledTools, runId, convertedTools, model, modelToPass, params, argsForExecute;
      return _regeneratorRuntime().wrap(function _callee5$(_context5) {
        while (1) switch (_context5.prev = _context5.next) {
          case 0:
            messages = _ref9.messages, _onStepFinish = _ref9.onStepFinish, _ref9$maxSteps = _ref9.maxSteps, maxSteps = _ref9$maxSteps === void 0 ? 5 : _ref9$maxSteps, enabledTools = _ref9.enabledTools, runId = _ref9.runId, convertedTools = _ref9.convertedTools;
            model = _classPrivateFieldLooseBase(this, _model)[_model];
            _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Generating text with " + messages.length + " messages", runId);
            if ('name' in model) {
              modelToPass = {
                type: this.getModelType(),
                name: model.name,
                toolChoice: model.toolChoice,
                apiKey: model.provider !== 'LM_STUDIO' ? model == null ? void 0 : model.apiKey : undefined,
                baseURL: model.provider === 'LM_STUDIO' ? model.baseURL : undefined,
                fetch: model.provider === 'BASETEN' ? model.fetch : undefined
              };
            } else {
              modelToPass = model;
            }
            _context5.next = 6;
            return this.getParams({
              tools: convertedTools || this.convertTools(enabledTools || {}),
              model: modelToPass
            });
          case 6:
            params = _context5.sent;
            argsForExecute = {
              model: params.modelDef,
              tools: _extends({}, params.toolsConverted, params.answerTool),
              toolChoice: params.toolChoice,
              maxSteps: maxSteps,
              onStepFinish: function () {
                var _onStepFinish2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee4(props) {
                  var _props$response, _props$response2;
                  return _regeneratorRuntime().wrap(function _callee4$(_context4) {
                    while (1) switch (_context4.prev = _context4.next) {
                      case 0:
                        _onStepFinish == null || _onStepFinish(JSON.stringify(props, null, 2));
                        if (!(props != null && (_props$response = props.response) != null && (_props$response = _props$response.headers) != null && _props$response['x-ratelimit-remaining-tokens'] && parseInt(props == null || (_props$response2 = props.response) == null || (_props$response2 = _props$response2.headers) == null ? void 0 : _props$response2['x-ratelimit-remaining-tokens'], 10) < 2000)) {
                          _context4.next = 5;
                          break;
                        }
                        _classPrivateFieldLooseBase(_this3, _logger$2)[_logger$2].warn('Rate limit approaching, waiting 10 seconds');
                        _context4.next = 5;
                        return delay(10 * 1000);
                      case 5:
                      case "end":
                        return _context4.stop();
                    }
                  }, _callee4);
                }));
                function onStepFinish(_x6) {
                  return _onStepFinish2.apply(this, arguments);
                }
                return onStepFinish;
              }()
            };
            _context5.next = 10;
            return generateText(_extends({
              messages: messages
            }, argsForExecute, {
              experimental_telemetry: this.experimental_telemetry
            }));
          case 10:
            return _context5.abrupt("return", _context5.sent);
          case 11:
          case "end":
            return _context5.stop();
        }
      }, _callee5, this);
    }));
    function __text(_x5) {
      return _text.apply(this, arguments);
    }
    return __text;
  }();
  _proto.__textObject = /*#__PURE__*/function () {
    var _textObject = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee7(_ref10) {
      var _this4 = this;
      var messages, _onStepFinish3, _ref10$maxSteps, maxSteps, enabledTools, convertedTools, structuredOutput, runId, model, modelToPass, params, argsForExecute, schema, output;
      return _regeneratorRuntime().wrap(function _callee7$(_context7) {
        while (1) switch (_context7.prev = _context7.next) {
          case 0:
            messages = _ref10.messages, _onStepFinish3 = _ref10.onStepFinish, _ref10$maxSteps = _ref10.maxSteps, maxSteps = _ref10$maxSteps === void 0 ? 5 : _ref10$maxSteps, enabledTools = _ref10.enabledTools, convertedTools = _ref10.convertedTools, structuredOutput = _ref10.structuredOutput, runId = _ref10.runId;
            model = _classPrivateFieldLooseBase(this, _model)[_model];
            _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Generating text with " + messages.length + " messages", runId);
            if ('name' in model) {
              modelToPass = {
                type: this.getModelType(),
                name: model.name,
                toolChoice: model.toolChoice,
                apiKey: model.provider !== 'LM_STUDIO' ? model == null ? void 0 : model.apiKey : undefined,
                baseURL: model.provider === 'LM_STUDIO' ? model.baseURL : undefined,
                fetch: model.provider === 'BASETEN' ? model.fetch : undefined
              };
            } else {
              modelToPass = model;
            }
            _context7.next = 6;
            return this.getParams({
              tools: convertedTools || this.convertTools(enabledTools || {}),
              model: modelToPass
            });
          case 6:
            params = _context7.sent;
            argsForExecute = {
              model: params.modelDef,
              tools: _extends({}, params.toolsConverted, params.answerTool),
              toolChoice: params.toolChoice,
              maxSteps: maxSteps,
              onStepFinish: function () {
                var _onStepFinish4 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee6(props) {
                  var _props$response3, _props$response4;
                  return _regeneratorRuntime().wrap(function _callee6$(_context6) {
                    while (1) switch (_context6.prev = _context6.next) {
                      case 0:
                        _onStepFinish3 == null || _onStepFinish3(JSON.stringify(props, null, 2));
                        if (!(props != null && (_props$response3 = props.response) != null && (_props$response3 = _props$response3.headers) != null && _props$response3['x-ratelimit-remaining-tokens'] && parseInt(props == null || (_props$response4 = props.response) == null || (_props$response4 = _props$response4.headers) == null ? void 0 : _props$response4['x-ratelimit-remaining-tokens'], 10) < 2000)) {
                          _context6.next = 5;
                          break;
                        }
                        _classPrivateFieldLooseBase(_this4, _logger$2)[_logger$2].warn('Rate limit approaching, waiting 10 seconds', runId);
                        _context6.next = 5;
                        return delay(10 * 1000);
                      case 5:
                      case "end":
                        return _context6.stop();
                    }
                  }, _callee6);
                }));
                function onStepFinish(_x8) {
                  return _onStepFinish4.apply(this, arguments);
                }
                return onStepFinish;
              }()
            };
            output = 'object';
            if (typeof structuredOutput.parse === 'function') {
              schema = structuredOutput;
              if (schema instanceof z.ZodArray) {
                output = 'array';
                schema = schema._def.type;
              }
            } else {
              schema = this.createOutputSchema(structuredOutput);
            }
            _context7.next = 12;
            return generateObject(_extends({
              messages: messages
            }, argsForExecute, {
              output: output,
              schema: schema,
              experimental_telemetry: this.experimental_telemetry
            }));
          case 12:
            return _context7.abrupt("return", _context7.sent);
          case 13:
          case "end":
            return _context7.stop();
        }
      }, _callee7, this);
    }));
    function __textObject(_x7) {
      return _textObject.apply(this, arguments);
    }
    return __textObject;
  }();
  _proto.__stream = /*#__PURE__*/function () {
    var _stream = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee10(_ref11) {
      var _this5 = this;
      var messages, _onStepFinish5, _onFinish, _ref11$maxSteps, maxSteps, enabledTools, runId, convertedTools, model, modelToPass, params, argsForExecute;
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) switch (_context10.prev = _context10.next) {
          case 0:
            messages = _ref11.messages, _onStepFinish5 = _ref11.onStepFinish, _onFinish = _ref11.onFinish, _ref11$maxSteps = _ref11.maxSteps, maxSteps = _ref11$maxSteps === void 0 ? 5 : _ref11$maxSteps, enabledTools = _ref11.enabledTools, runId = _ref11.runId, convertedTools = _ref11.convertedTools;
            model = _classPrivateFieldLooseBase(this, _model)[_model];
            _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Streaming text with " + messages.length + " messages", runId);
            if ('name' in model) {
              modelToPass = {
                type: this.getModelType(),
                name: model.name,
                toolChoice: model.toolChoice,
                apiKey: model.provider !== 'LM_STUDIO' ? model == null ? void 0 : model.apiKey : undefined,
                baseURL: model.provider === 'LM_STUDIO' ? model.baseURL : undefined,
                fetch: model.provider === 'BASETEN' ? model.fetch : undefined
              };
            } else {
              modelToPass = model;
            }
            _context10.next = 6;
            return this.getParams({
              tools: convertedTools || this.convertTools(enabledTools),
              model: modelToPass
            });
          case 6:
            params = _context10.sent;
            argsForExecute = {
              model: params.modelDef,
              tools: _extends({}, params.toolsConverted, params.answerTool),
              toolChoice: params.toolChoice,
              maxSteps: maxSteps,
              onStepFinish: function () {
                var _onStepFinish6 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee8(props) {
                  var _props$response5, _props$response6;
                  return _regeneratorRuntime().wrap(function _callee8$(_context8) {
                    while (1) switch (_context8.prev = _context8.next) {
                      case 0:
                        _onStepFinish5 == null || _onStepFinish5(JSON.stringify(props, null, 2));
                        if (!(props != null && (_props$response5 = props.response) != null && (_props$response5 = _props$response5.headers) != null && _props$response5['x-ratelimit-remaining-tokens'] && parseInt(props == null || (_props$response6 = props.response) == null || (_props$response6 = _props$response6.headers) == null ? void 0 : _props$response6['x-ratelimit-remaining-tokens'], 10) < 2000)) {
                          _context8.next = 5;
                          break;
                        }
                        _classPrivateFieldLooseBase(_this5, _logger$2)[_logger$2].warn('Rate limit approaching, waiting 10 seconds', runId);
                        _context8.next = 5;
                        return delay(10 * 1000);
                      case 5:
                      case "end":
                        return _context8.stop();
                    }
                  }, _callee8);
                }));
                function onStepFinish(_x10) {
                  return _onStepFinish6.apply(this, arguments);
                }
                return onStepFinish;
              }(),
              onFinish: function () {
                var _onFinish2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee9(props) {
                  return _regeneratorRuntime().wrap(function _callee9$(_context9) {
                    while (1) switch (_context9.prev = _context9.next) {
                      case 0:
                        _onFinish == null || _onFinish(JSON.stringify(props, null, 2));
                      case 1:
                      case "end":
                        return _context9.stop();
                    }
                  }, _callee9);
                }));
                function onFinish(_x11) {
                  return _onFinish2.apply(this, arguments);
                }
                return onFinish;
              }()
            };
            _context10.next = 10;
            return streamText(_extends({
              messages: messages
            }, argsForExecute, {
              experimental_telemetry: this.experimental_telemetry
            }));
          case 10:
            return _context10.abrupt("return", _context10.sent);
          case 11:
          case "end":
            return _context10.stop();
        }
      }, _callee10, this);
    }));
    function __stream(_x9) {
      return _stream.apply(this, arguments);
    }
    return __stream;
  }();
  _proto.__streamObject = /*#__PURE__*/function () {
    var _streamObject = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee13(_ref12) {
      var _this6 = this;
      var messages, _onStepFinish7, _onFinish3, _ref12$maxSteps, maxSteps, enabledTools, convertedTools, structuredOutput, runId, model, modelToPass, params, argsForExecute, schema, output;
      return _regeneratorRuntime().wrap(function _callee13$(_context13) {
        while (1) switch (_context13.prev = _context13.next) {
          case 0:
            messages = _ref12.messages, _onStepFinish7 = _ref12.onStepFinish, _onFinish3 = _ref12.onFinish, _ref12$maxSteps = _ref12.maxSteps, maxSteps = _ref12$maxSteps === void 0 ? 5 : _ref12$maxSteps, enabledTools = _ref12.enabledTools, convertedTools = _ref12.convertedTools, structuredOutput = _ref12.structuredOutput, runId = _ref12.runId;
            model = _classPrivateFieldLooseBase(this, _model)[_model];
            _classPrivateFieldLooseBase(this, _log$2)[_log$2](LogLevel.DEBUG, "Streaming text with " + messages.length + " messages", runId);
            if ('name' in model) {
              modelToPass = {
                type: this.getModelType(),
                name: model.name,
                toolChoice: model.toolChoice,
                apiKey: model.provider !== 'LM_STUDIO' ? model == null ? void 0 : model.apiKey : undefined,
                baseURL: model.provider === 'LM_STUDIO' ? model.baseURL : undefined,
                fetch: model.provider === 'BASETEN' ? model.fetch : undefined
              };
            } else {
              modelToPass = model;
            }
            _context13.next = 6;
            return this.getParams({
              tools: convertedTools || this.convertTools(enabledTools),
              model: modelToPass
            });
          case 6:
            params = _context13.sent;
            argsForExecute = {
              model: params.modelDef,
              tools: _extends({}, params.toolsConverted, params.answerTool),
              toolChoice: params.toolChoice,
              maxSteps: maxSteps,
              onStepFinish: function () {
                var _onStepFinish8 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee11(props) {
                  var _props$response7, _props$response8;
                  return _regeneratorRuntime().wrap(function _callee11$(_context11) {
                    while (1) switch (_context11.prev = _context11.next) {
                      case 0:
                        _onStepFinish7 == null || _onStepFinish7(JSON.stringify(props, null, 2));
                        if (!(props != null && (_props$response7 = props.response) != null && (_props$response7 = _props$response7.headers) != null && _props$response7['x-ratelimit-remaining-tokens'] && parseInt(props == null || (_props$response8 = props.response) == null || (_props$response8 = _props$response8.headers) == null ? void 0 : _props$response8['x-ratelimit-remaining-tokens'], 10) < 2000)) {
                          _context11.next = 5;
                          break;
                        }
                        _classPrivateFieldLooseBase(_this6, _logger$2)[_logger$2].warn('Rate limit approaching, waiting 10 seconds', runId);
                        _context11.next = 5;
                        return delay(10 * 1000);
                      case 5:
                      case "end":
                        return _context11.stop();
                    }
                  }, _callee11);
                }));
                function onStepFinish(_x13) {
                  return _onStepFinish8.apply(this, arguments);
                }
                return onStepFinish;
              }(),
              onFinish: function () {
                var _onFinish4 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee12(props) {
                  return _regeneratorRuntime().wrap(function _callee12$(_context12) {
                    while (1) switch (_context12.prev = _context12.next) {
                      case 0:
                        _onFinish3 == null || _onFinish3(JSON.stringify(props, null, 2));
                      case 1:
                      case "end":
                        return _context12.stop();
                    }
                  }, _callee12);
                }));
                function onFinish(_x14) {
                  return _onFinish4.apply(this, arguments);
                }
                return onFinish;
              }()
            };
            output = 'object';
            if (typeof structuredOutput.parse === 'function') {
              schema = structuredOutput;
              if (schema instanceof z.ZodArray) {
                output = 'array';
                schema = schema._def.type;
              }
            } else {
              schema = this.createOutputSchema(structuredOutput);
            }
            _context13.next = 12;
            return streamObject(_extends({
              messages: messages
            }, argsForExecute, {
              output: output,
              schema: schema,
              experimental_telemetry: this.experimental_telemetry
            }));
          case 12:
            return _context13.abrupt("return", _context13.sent);
          case 13:
          case "end":
            return _context13.stop();
        }
      }, _callee13, this);
    }));
    function __streamObject(_x12) {
      return _streamObject.apply(this, arguments);
    }
    return __streamObject;
  }();
  return _createClass(LLM, [{
    key: "experimental_telemetry",
    get: function get() {
      return _classPrivateFieldLooseBase(this, _telemetry$4)[_telemetry$4] ? {
        tracer: _classPrivateFieldLooseBase(this, _telemetry$4)[_telemetry$4].tracer,
        isEnabled: !!_classPrivateFieldLooseBase(this, _telemetry$4)[_telemetry$4].tracer
      } : undefined;
    }
  }]);
}());
function _log2$2(level, message, runId) {
  var _classPrivateFieldLoo, _classPrivateFieldLoo2;
  if (!_classPrivateFieldLooseBase(this, _logger$2)[_logger$2]) return;
  var logMessage = {
    type: RegisteredLogger.LLM,
    message: message,
    destinationPath: 'LLM',
    runId: runId
  };
  var logMethod = level.toLowerCase();
  (_classPrivateFieldLoo = (_classPrivateFieldLoo2 = _classPrivateFieldLooseBase(this, _logger$2)[_logger$2])[logMethod]) == null || _classPrivateFieldLoo.call(_classPrivateFieldLoo2, logMessage);
}
LLM = /*#__PURE__*/__decorate([/*#__PURE__*/InstrumentClass({
  prefix: 'llm',
  excludeMethods: ['__setTools', '__setLogger', '__setTelemetry', '#log']
}), /*#__PURE__*/__metadata("design:paramtypes", [Object])], LLM);

// Store SDK instance outside the class to persist across HMR
var sdkInstance = null;
var Telemetry = /*#__PURE__*/function () {
  function Telemetry(config) {
    var _config$serviceName;
    this.sdk = null;
    this.tracer = trace.getTracer('default');
    this.name = 'default-service';
    this.name = (_config$serviceName = config.serviceName) != null ? _config$serviceName : 'default-service';
    // Only initialize in server environment
    if (typeof window === 'undefined') {
      // In development, always create a new instance
      // In production, use existing instance if available
      if (process.env.NODE_ENV === 'development' || !sdkInstance) {
        var _config$export, _Resource;
        // Shutdown existing instance if it exists
        if (sdkInstance) {
          this.shutdown();
        }
        var exporter = ((_config$export = config["export"]) == null ? void 0 : _config$export.type) === 'otlp' ? new OTLPTraceExporter({
          url: config["export"].endpoint,
          headers: config["export"].headers
        }) : new ConsoleSpanExporter();
        var sampler = this.getSampler(config);
        sdkInstance = new NodeSDK({
          resource: new Resource((_Resource = {}, _Resource[ATTR_SERVICE_NAME] = this.name, _Resource)),
          traceExporter: exporter,
          sampler: sampler,
          instrumentations: [getNodeAutoInstrumentations()]
        });
        try {
          sdkInstance.start();
          this.sdk = sdkInstance;
          Telemetry.isInitialized = true;
        } catch (error) {
          console.warn('Failed to initialize OpenTelemetry:', error);
        }
      }
    }
    this.tracer = trace.getTracer(this.name);
  }
  var _proto = Telemetry.prototype;
  _proto.getSampler = function getSampler(config) {
    var _config$sampling$root;
    if (!config.sampling) {
      return new AlwaysOnSampler();
    }
    switch (config.sampling.type) {
      case 'ratio':
        return new TraceIdRatioBasedSampler(config.sampling.probability);
      case 'always_on':
        return new AlwaysOnSampler();
      case 'always_off':
        return new AlwaysOffSampler();
      case 'parent_based':
        var rootSampler = new TraceIdRatioBasedSampler(((_config$sampling$root = config.sampling.root) == null ? void 0 : _config$sampling$root.probability) || 1.0);
        return new ParentBasedSampler({
          root: rootSampler
        });
      default:
        return new AlwaysOnSampler();
    }
  };
  _proto.shutdown = /*#__PURE__*/function () {
    var _shutdown = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (!(this.sdk && Telemetry.isInitialized)) {
              _context.next = 12;
              break;
            }
            _context.prev = 1;
            _context.next = 4;
            return this.sdk.shutdown();
          case 4:
            Telemetry.isInitialized = false;
            global.__OTEL_SDK__ = undefined;
            global.__TELEMETRY__ = undefined;
            _context.next = 12;
            break;
          case 9:
            _context.prev = 9;
            _context.t0 = _context["catch"](1);
            console.warn('Error shutting down OpenTelemetry:', _context.t0);
          case 12:
          case "end":
            return _context.stop();
        }
      }, _callee, this, [[1, 9]]);
    }));
    function shutdown() {
      return _shutdown.apply(this, arguments);
    }
    return shutdown;
  }()
  /**
   * Initialize telemetry with the given configuration
   * @param config - Optional telemetry configuration object
   * @returns Telemetry instance that can be used for tracing
   */
  ;
  Telemetry.init = function init(config) {
    if (config === void 0) {
      config = {};
    }
    try {
      if (!global.__TELEMETRY__) {
        global.__TELEMETRY__ = new Telemetry(config);
      }
      return global.__TELEMETRY__;
    } catch (error) {
      console.error('Failed to initialize telemetry:', error);
      throw error;
    }
  }
  /**
   * Get the global telemetry instance
   * @throws {Error} If telemetry has not been initialized
   * @returns {Telemetry} The global telemetry instance
   */;
  Telemetry.get = function get() {
    if (!global.__TELEMETRY__) {
      throw new Error('Telemetry not initialized');
    }
    return global.__TELEMETRY__;
  }
  /**
   * Wraps a class instance with telemetry tracing
   * @param instance The class instance to wrap
   * @param options Optional configuration for tracing
   * @returns Wrapped instance with all methods traced
   */;
  _proto.traceClass = function traceClass(instance, options) {
    var _this = this;
    if (options === void 0) {
      options = {};
    }
    var _options = options,
      _options$skipIfNoTele = _options.skipIfNoTelemetry,
      skipIfNoTelemetry = _options$skipIfNoTele === void 0 ? true : _options$skipIfNoTele;
    // Skip if no telemetry is active and skipIfNoTelemetry is true
    if (skipIfNoTelemetry && !hasActiveTelemetry()) {
      return instance;
    }
    var _options2 = options,
      _options2$spanNamePre = _options2.spanNamePrefix,
      spanNamePrefix = _options2$spanNamePre === void 0 ? instance.constructor.name.toLowerCase() : _options2$spanNamePre,
      _options2$attributes = _options2.attributes,
      attributes = _options2$attributes === void 0 ? {} : _options2$attributes,
      _options2$excludeMeth = _options2.excludeMethods,
      excludeMethods = _options2$excludeMeth === void 0 ? [] : _options2$excludeMeth;
    return new Proxy(instance, {
      get: function get(target, prop) {
        var value = target[prop];
        // Skip tracing for excluded methods, constructors, private methods
        if (typeof value === 'function' && prop !== 'constructor' && !prop.toString().startsWith('_') && !excludeMethods.includes(prop.toString())) {
          var _extends2;
          return _this.traceMethod(value.bind(target), {
            spanName: spanNamePrefix + "." + prop.toString(),
            attributes: _extends({}, attributes, (_extends2 = {}, _extends2[spanNamePrefix + ".name"] = target.constructor.name, _extends2[spanNamePrefix + ".method.name"] = prop.toString(), _extends2))
          });
        }
        return value;
      }
    });
  }
  /**
   * method to trace individual methods with proper context
   * @param method The method to trace
   * @param context Additional context for the trace
   * @returns Wrapped method with tracing
   */;
  _proto.traceMethod = function traceMethod(method, context) {
    var _this2 = this;
    var _context$skipIfNoTele = context.skipIfNoTelemetry,
      skipIfNoTelemetry = _context$skipIfNoTele === void 0 ? true : _context$skipIfNoTele;
    // Skip if no telemetry is active and skipIfNoTelemetry is true
    if (skipIfNoTelemetry && !hasActiveTelemetry()) {
      return method;
    }
    return /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
      var span,
        _len,
        args,
        _key,
        result,
        _args2 = arguments;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            span = _this2.tracer.startSpan(context.spanName);
            _context2.prev = 1;
            // Add all context attributes to span
            if (context.attributes) {
              span.setAttributes(context.attributes);
            }
            // Record input arguments as span attributes
            for (_len = _args2.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = _args2[_key];
            }
            args.forEach(function (arg, index) {
              try {
                span.setAttribute(context.spanName + ".argument." + index, JSON.stringify(arg));
              } catch (e) {
                span.setAttribute(context.spanName + ".argument." + index, '[Not Serializable]');
              }
            });
            _context2.next = 7;
            return method.apply(void 0, args);
          case 7:
            result = _context2.sent;
            // Record result
            try {
              span.setAttribute(context.spanName + ".result", JSON.stringify(result));
            } catch (e) {
              span.setAttribute(context.spanName + ".result", '[Not Serializable]');
            }
            span.end();
            return _context2.abrupt("return", result);
          case 13:
            _context2.prev = 13;
            _context2.t0 = _context2["catch"](1);
            span.recordException(_context2.t0);
            span.setStatus({
              code: SpanStatusCode.ERROR,
              message: _context2.t0.message
            });
            span.end();
            throw _context2.t0;
          case 19:
          case "end":
            return _context2.stop();
        }
      }, _callee2, null, [[1, 13]]);
    }));
  };
  return Telemetry;
}();
Telemetry.isInitialized = false;

var _tools, _logger$1, _telemetry$3, _log$1;
var Agent = (_tools = /*#__PURE__*/_classPrivateFieldLooseKey("tools"), _logger$1 = /*#__PURE__*/_classPrivateFieldLooseKey("logger"), _telemetry$3 = /*#__PURE__*/_classPrivateFieldLooseKey("telemetry"), _log$1 = /*#__PURE__*/_classPrivateFieldLooseKey("log"), /*#__PURE__*/function () {
  function Agent(config) {
    /**
     * Internal logging helper that formats and sends logs to the configured logger
     * @param level - Severity level of the log
     * @param message - Main log message
     * @param runId - Optional runId for the log
     */
    Object.defineProperty(this, _log$1, {
      value: _log2$1
    });
    this.name = void 0;
    this.memory = void 0;
    this.llm = void 0;
    this.instructions = void 0;
    this.model = void 0;
    this.enabledTools = void 0;
    Object.defineProperty(this, _tools, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _logger$1, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _telemetry$3, {
      writable: true,
      value: void 0
    });
    this.name = config.name;
    this.instructions = config.instructions;
    this.llm = new LLM({
      model: config.model
    });
    this.model = config.model;
    this.enabledTools = config.enabledTools || {};
    _classPrivateFieldLooseBase(this, _logger$1)[_logger$1] = createLogger({
      type: 'CONSOLE'
    });
    _classPrivateFieldLooseBase(this, _logger$1)[_logger$1].info("Agent " + this.name + " initialized with model " + this.model.provider);
    _classPrivateFieldLooseBase(this, _tools)[_tools] = {};
  }
  /**
   * Set the concrete tools for the agent
   * @param tools
   */
  var _proto = Agent.prototype;
  _proto.__setTools = function __setTools(tools) {
    this.llm.__setTools(tools);
    _classPrivateFieldLooseBase(this, _tools)[_tools] = tools;
    _classPrivateFieldLooseBase(this, _log$1)[_log$1](LogLevel.DEBUG, "Tools set for agent " + this.name);
  }
  /**
   * Set the logger for the agent
   * @param logger
   */;
  _proto.__setLogger = function __setLogger(logger) {
    _classPrivateFieldLooseBase(this, _logger$1)[_logger$1] = logger;
    this.llm.__setLogger(logger);
    _classPrivateFieldLooseBase(this, _log$1)[_log$1](LogLevel.DEBUG, "Logger updated for agent " + this.name);
  };
  _proto.__setMemory = function __setMemory(memory) {
    this.memory = memory;
    _classPrivateFieldLooseBase(this, _log$1)[_log$1](LogLevel.DEBUG, "Memory set for agent " + this.name);
  }
  /**
   * Set the telemetry for the agent
   * @param telemetry
   */;
  _proto.__setTelemetry = function __setTelemetry(telemetry) {
    _classPrivateFieldLooseBase(this, _telemetry$3)[_telemetry$3] = telemetry;
    this.llm.__setTelemetry(_classPrivateFieldLooseBase(this, _telemetry$3)[_telemetry$3]);
    _classPrivateFieldLooseBase(this, _log$1)[_log$1](LogLevel.DEBUG, "Telemetry updated for agent " + this.name);
  };
  _proto.generateTitleFromUserMessage = /*#__PURE__*/function () {
    var _generateTitleFromUserMessage = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref) {
      var message, _yield$this$llm$__tex, title;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            message = _ref.message;
            _context.next = 3;
            return this.llm.__text({
              messages: [{
                role: 'system',
                content: "\n\n      - you will generate a short title based on the first message a user begins a conversation with\n      - ensure it is not more than 80 characters long\n      - the title should be a summary of the user's message\n      - do not use quotes or colons"
              }, {
                role: 'user',
                content: JSON.stringify(message)
              }]
            });
          case 3:
            _yield$this$llm$__tex = _context.sent;
            title = _yield$this$llm$__tex.text;
            return _context.abrupt("return", title);
          case 6:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function generateTitleFromUserMessage(_x) {
      return _generateTitleFromUserMessage.apply(this, arguments);
    }
    return generateTitleFromUserMessage;
  }();
  _proto.getMostRecentUserMessage = function getMostRecentUserMessage(messages) {
    var userMessages = messages.filter(function (message) {
      return message.role === 'user';
    });
    return userMessages.at(-1);
  };
  _proto.genTitle = /*#__PURE__*/function () {
    var _genTitle = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(userMessage) {
      var title;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            title = 'New Thread';
            _context2.prev = 1;
            if (!userMessage) {
              _context2.next = 6;
              break;
            }
            _context2.next = 5;
            return this.generateTitleFromUserMessage({
              message: userMessage
            });
          case 5:
            title = _context2.sent;
          case 6:
            _context2.next = 11;
            break;
          case 8:
            _context2.prev = 8;
            _context2.t0 = _context2["catch"](1);
            console.error('Error generating title:', _context2.t0);
          case 11:
            return _context2.abrupt("return", title);
          case 12:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this, [[1, 8]]);
    }));
    function genTitle(_x2) {
      return _genTitle.apply(this, arguments);
    }
    return genTitle;
  }();
  _proto.saveMemory = /*#__PURE__*/function () {
    var _saveMemory = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3(_ref2) {
      var _this = this;
      var threadId, resourceid, userMessages, userMessage, _thread, thread, title, _title, newMessages, _context$object, messages, contextCallMessages, context, memoryMessages, _context$object2, _context$object3, _context$object4, _context$object5;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            threadId = _ref2.threadId, resourceid = _ref2.resourceid, userMessages = _ref2.userMessages;
            userMessage = this.getMostRecentUserMessage(userMessages);
            if (!this.memory) {
              _context3.next = 44;
              break;
            }
            _classPrivateFieldLooseBase(this, _logger$1)[_logger$1].debug('SAVING', {
              threadId: threadId,
              resourceid: resourceid
            });
            if (threadId) {
              _context3.next = 13;
              break;
            }
            _context3.next = 7;
            return this.genTitle(userMessage);
          case 7:
            title = _context3.sent;
            _context3.next = 10;
            return this.memory.createThread({
              threadId: threadId,
              resourceid: resourceid,
              title: title
            });
          case 10:
            thread = _context3.sent;
            _context3.next = 23;
            break;
          case 13:
            _context3.next = 15;
            return this.memory.getThreadById({
              threadId: threadId
            });
          case 15:
            thread = _context3.sent;
            if (thread) {
              _context3.next = 23;
              break;
            }
            _context3.next = 19;
            return this.genTitle(userMessage);
          case 19:
            _title = _context3.sent;
            _context3.next = 22;
            return this.memory.createThread({
              threadId: threadId,
              resourceid: resourceid,
              title: _title
            });
          case 22:
            thread = _context3.sent;
          case 23:
            newMessages = userMessage ? [userMessage] : userMessages;
            if (!thread) {
              _context3.next = 43;
              break;
            }
            messages = newMessages.map(function (u) {
              var _this$memory;
              return _extends({
                id: (_this$memory = _this.memory) == null ? void 0 : _this$memory.generateId(),
                createdAt: new Date(),
                threadId: thread.id
              }, u, {
                content: u.content,
                role: u.role,
                type: 'text'
              });
            });
            contextCallMessages = [{
              role: 'system',
              content: "Analyze this message to determine if the user is referring to a previous conversation with the LLM. Specifically, identify if the user wants to reference specific information from that chat or if they want the LLM to use the previous chat messages as context for the current conversation. Extract any date ranges mentioned in the user message that could help identify the previous chat. Return dates in ISO format. If no specific dates are mentioned but time periods are (like \"last week\" or \"past month\"), calculate the appropriate date range. For the end date, return the date 1 day after the end of the time period. Today's date is " + new Date().toISOString()
            }].concat(newMessages);
            _context3.next = 29;
            return this.llm.__textObject({
              messages: contextCallMessages,
              structuredOutput: {
                usesContext: {
                  type: 'boolean'
                },
                startDate: {
                  type: 'date'
                },
                endDate: {
                  type: 'date'
                }
              }
            });
          case 29:
            context = _context3.sent;
            _classPrivateFieldLooseBase(this, _logger$1)[_logger$1].debug('Text Object result', JSON.stringify(context.object, null, 2));
            if (!((_context$object = context.object) != null && _context$object.usesContext)) {
              _context3.next = 37;
              break;
            }
            _context3.next = 34;
            return this.memory.getContextWindow({
              threadId: thread.id,
              format: 'core_message',
              startDate: (_context$object2 = context.object) != null && _context$object2.startDate ? new Date((_context$object3 = context.object) == null ? void 0 : _context$object3.startDate) : undefined,
              endDate: (_context$object4 = context.object) != null && _context$object4.endDate ? new Date((_context$object5 = context.object) == null ? void 0 : _context$object5.endDate) : undefined
            });
          case 34:
            memoryMessages = _context3.sent;
            _context3.next = 40;
            break;
          case 37:
            _context3.next = 39;
            return this.memory.getContextWindow({
              threadId: thread.id,
              format: 'core_message'
            });
          case 39:
            memoryMessages = _context3.sent;
          case 40:
            _context3.next = 42;
            return this.memory.saveMessages({
              messages: messages
            });
          case 42:
            return _context3.abrupt("return", {
              threadId: thread.id,
              messages: [].concat(memoryMessages, newMessages)
            });
          case 43:
            return _context3.abrupt("return", {
              threadId: ((_thread = thread) == null ? void 0 : _thread.id) || threadId || '',
              messages: userMessages
            });
          case 44:
            return _context3.abrupt("return", {
              threadId: threadId || '',
              messages: userMessages
            });
          case 45:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this);
    }));
    function saveMemory(_x3) {
      return _saveMemory.apply(this, arguments);
    }
    return saveMemory;
  }();
  _proto.saveResponse = /*#__PURE__*/function () {
    var _saveResponse = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee4(_ref3) {
      var result, threadId, response, ms, responseMessagesWithoutIncompleteToolCalls;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            result = _ref3.result, threadId = _ref3.threadId;
            response = result.response;
            _context4.prev = 2;
            if (!response.messages) {
              _context4.next = 10;
              break;
            }
            ms = Array.isArray(response.messages) ? response.messages : [response.messages];
            responseMessagesWithoutIncompleteToolCalls = this.sanitizeResponseMessages(ms);
            if (!this.memory) {
              _context4.next = 10;
              break;
            }
            _classPrivateFieldLooseBase(this, _logger$1)[_logger$1].debug('Saving response to memory', {
              threadId: threadId
            });
            _context4.next = 10;
            return this.memory.saveMessages({
              messages: responseMessagesWithoutIncompleteToolCalls.map(function (message) {
                var _toolCallIds, _toolCallArgs, _toolNames;
                var messageId = randomUUID();
                var toolCallIds;
                var toolCallArgs;
                var toolNames;
                var type = 'text';
                if (message.role === 'tool') {
                  toolCallIds = message.content.map(function (content) {
                    return content.toolCallId;
                  });
                  type = 'tool-result';
                }
                if (message.role === 'assistant') {
                  var _assistantContent$map, _assistantContent$;
                  var assistantContent = message.content;
                  var assistantToolCalls = (_assistantContent$map = assistantContent.map(function (content) {
                    if (content.type === 'tool-call') {
                      return {
                        toolCallId: content.toolCallId,
                        toolArgs: content.args,
                        toolName: content.toolName
                      };
                    }
                    return undefined;
                  })) == null ? void 0 : _assistantContent$map.filter(Boolean);
                  toolCallIds = assistantToolCalls == null ? void 0 : assistantToolCalls.map(function (toolCall) {
                    return toolCall.toolCallId;
                  });
                  toolCallArgs = assistantToolCalls == null ? void 0 : assistantToolCalls.map(function (toolCall) {
                    return toolCall.toolArgs;
                  });
                  toolNames = assistantToolCalls == null ? void 0 : assistantToolCalls.map(function (toolCall) {
                    return toolCall.toolName;
                  });
                  type = assistantContent == null || (_assistantContent$ = assistantContent[0]) == null ? void 0 : _assistantContent$.type;
                }
                return {
                  id: messageId,
                  threadId: threadId,
                  role: message.role,
                  content: message.content,
                  createdAt: new Date(),
                  toolCallIds: (_toolCallIds = toolCallIds) != null && _toolCallIds.length ? toolCallIds : undefined,
                  toolCallArgs: (_toolCallArgs = toolCallArgs) != null && _toolCallArgs.length ? toolCallArgs : undefined,
                  toolNames: (_toolNames = toolNames) != null && _toolNames.length ? toolNames : undefined,
                  type: type
                };
              })
            });
          case 10:
            _context4.next = 15;
            break;
          case 12:
            _context4.prev = 12;
            _context4.t0 = _context4["catch"](2);
            console.error('Failed to save chat', _context4.t0);
          case 15:
          case "end":
            return _context4.stop();
        }
      }, _callee4, this, [[2, 12]]);
    }));
    function saveResponse(_x4) {
      return _saveResponse.apply(this, arguments);
    }
    return saveResponse;
  }();
  _proto.sanitizeResponseMessages = function sanitizeResponseMessages(messages) {
    var toolResultIds = [];
    for (var _iterator = _createForOfIteratorHelperLoose(messages), _step; !(_step = _iterator()).done;) {
      var message = _step.value;
      if (message.role === 'tool') {
        for (var _iterator2 = _createForOfIteratorHelperLoose(message.content), _step2; !(_step2 = _iterator2()).done;) {
          var content = _step2.value;
          if (content.type === 'tool-result') {
            toolResultIds.push(content.toolCallId);
          }
        }
      }
    }
    var messagesBySanitizedContent = messages.map(function (message) {
      if (message.role !== 'assistant') return message;
      if (typeof message.content === 'string') return message;
      var sanitizedContent = message.content.filter(function (content) {
        return content.type === 'tool-call' ? toolResultIds.includes(content.toolCallId) : content.type === 'text' ? content.text.length > 0 : true;
      });
      return _extends({}, message, {
        content: sanitizedContent
      });
    });
    return messagesBySanitizedContent.filter(function (message) {
      return message.content.length > 0;
    });
  };
  _proto.convertTools = function convertTools(_ref4) {
    var _this2 = this;
    var enabledTools = _ref4.enabledTools,
      threadId = _ref4.threadId,
      runId = _ref4.runId;
    var converted = Object.entries(enabledTools || {}).reduce(function (memo, value) {
      var k = value[0];
      var enabled = value[1];
      var tool = _classPrivateFieldLooseBase(_this2, _tools)[_tools][k];
      if (enabled && tool) {
        memo[k] = {
          description: tool.description,
          parameters: z.object({
            data: tool.schema
          }),
          execute: function () {
            var _execute = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee5(args) {
              var _this2$memory, cachedResult;
              return _regeneratorRuntime().wrap(function _callee5$(_context5) {
                while (1) switch (_context5.prev = _context5.next) {
                  case 0:
                    if (!tool.enableCache) {
                      _context5.next = 7;
                      break;
                    }
                    _context5.next = 3;
                    return (_this2$memory = _this2.memory) == null ? void 0 : _this2$memory.getToolResult({
                      threadId: threadId,
                      toolArgs: args,
                      toolName: k
                    });
                  case 3:
                    cachedResult = _context5.sent;
                    if (!cachedResult) {
                      _context5.next = 7;
                      break;
                    }
                    _classPrivateFieldLooseBase(_this2, _logger$1)[_logger$1].debug("Cached Result " + k + " runId: " + runId, JSON.stringify(cachedResult, null, 2));
                    return _context5.abrupt("return", cachedResult);
                  case 7:
                    _classPrivateFieldLooseBase(_this2, _logger$1)[_logger$1].debug("Cache not found or not enabled, executing tool runId: " + runId, runId);
                    return _context5.abrupt("return", tool.executor(args));
                  case 9:
                  case "end":
                    return _context5.stop();
                }
              }, _callee5);
            }));
            function execute(_x5) {
              return _execute.apply(this, arguments);
            }
            return execute;
          }()
        };
      }
      return memo;
    }, {});
    _classPrivateFieldLooseBase(this, _log$1)[_log$1](LogLevel.DEBUG, "Converted tools for Agent " + this.name, runId);
    return converted;
  };
  _proto.preExecute = /*#__PURE__*/function () {
    var _preExecute = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee6(_ref5) {
      var resourceid, runId, threadId, messages, coreMessages, threadIdToUse, saveMessageResponse;
      return _regeneratorRuntime().wrap(function _callee6$(_context6) {
        while (1) switch (_context6.prev = _context6.next) {
          case 0:
            resourceid = _ref5.resourceid, runId = _ref5.runId, threadId = _ref5.threadId, messages = _ref5.messages;
            coreMessages = [];
            threadIdToUse = threadId;
            _classPrivateFieldLooseBase(this, _log$1)[_log$1](LogLevel.INFO, "Saving user messages in memory for agent " + this.name, runId);
            _context6.next = 6;
            return this.saveMemory({
              threadId: threadId,
              resourceid: resourceid,
              userMessages: messages
            });
          case 6:
            saveMessageResponse = _context6.sent;
            coreMessages = saveMessageResponse.messages;
            threadIdToUse = saveMessageResponse.threadId;
            return _context6.abrupt("return", {
              coreMessages: coreMessages,
              threadIdToUse: threadIdToUse
            });
          case 10:
          case "end":
            return _context6.stop();
        }
      }, _callee6, this);
    }));
    function preExecute(_x6) {
      return _preExecute.apply(this, arguments);
    }
    return preExecute;
  }();
  _proto.__primitive = function __primitive(_ref6) {
    var _this3 = this;
    var messages = _ref6.messages,
      context = _ref6.context,
      threadId = _ref6.threadId,
      resourceid = _ref6.resourceid,
      runId = _ref6.runId;
    return {
      before: function () {
        var _before = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee7() {
          var systemMessage, userMessages, coreMessages, convertedTools, threadIdToUse, preExecuteResult, messageObjects;
          return _regeneratorRuntime().wrap(function _callee7$(_context7) {
            while (1) switch (_context7.prev = _context7.next) {
              case 0:
                _classPrivateFieldLooseBase(_this3, _log$1)[_log$1](LogLevel.INFO, "Starting generation for agent " + _this3.name, runId);
                systemMessage = {
                  role: 'system',
                  content: _this3.instructions + ". Today's date is " + new Date().toISOString()
                };
                userMessages = messages.map(function (content) {
                  return {
                    role: 'user',
                    content: content
                  };
                });
                coreMessages = userMessages;
                threadIdToUse = threadId;
                if (!(_this3.memory && resourceid)) {
                  _context7.next = 12;
                  break;
                }
                _context7.next = 8;
                return _this3.preExecute({
                  resourceid: resourceid,
                  runId: runId,
                  threadId: threadIdToUse,
                  messages: userMessages
                });
              case 8:
                preExecuteResult = _context7.sent;
                coreMessages = preExecuteResult.coreMessages;
                threadIdToUse = preExecuteResult.threadIdToUse;
                convertedTools = _this3.convertTools({
                  enabledTools: _this3.enabledTools,
                  threadId: threadIdToUse,
                  runId: runId
                });
              case 12:
                messageObjects = [systemMessage].concat(context || [], coreMessages);
                return _context7.abrupt("return", {
                  messageObjects: messageObjects,
                  convertedTools: convertedTools,
                  threadId: threadIdToUse
                });
              case 14:
              case "end":
                return _context7.stop();
            }
          }, _callee7);
        }));
        function before() {
          return _before.apply(this, arguments);
        }
        return before;
      }(),
      after: function () {
        var _after = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee8(_ref7) {
          var result, threadId;
          return _regeneratorRuntime().wrap(function _callee8$(_context8) {
            while (1) switch (_context8.prev = _context8.next) {
              case 0:
                result = _ref7.result, threadId = _ref7.threadId;
                if (!(_this3.memory && resourceid)) {
                  _context8.next = 11;
                  break;
                }
                _context8.prev = 2;
                _classPrivateFieldLooseBase(_this3, _log$1)[_log$1](LogLevel.INFO, "Saving assistant message in memory for agent " + _this3.name, runId);
                _context8.next = 6;
                return _this3.saveResponse({
                  result: result,
                  threadId: threadId
                });
              case 6:
                _context8.next = 11;
                break;
              case 8:
                _context8.prev = 8;
                _context8.t0 = _context8["catch"](2);
                _classPrivateFieldLooseBase(_this3, _logger$1)[_logger$1].error('Error saving response', _context8.t0);
              case 11:
              case "end":
                return _context8.stop();
            }
          }, _callee8, null, [[2, 8]]);
        }));
        function after(_x7) {
          return _after.apply(this, arguments);
        }
        return after;
      }()
    };
  };
  _proto.text = /*#__PURE__*/function () {
    var _text = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee9(_ref8) {
      var messages, context, onStepFinish, _ref8$maxSteps, maxSteps, threadIdInFn, resourceid, runId, _this$__primitive, before, after, _yield$before, threadId, messageObjects, convertedTools, result;
      return _regeneratorRuntime().wrap(function _callee9$(_context9) {
        while (1) switch (_context9.prev = _context9.next) {
          case 0:
            messages = _ref8.messages, context = _ref8.context, onStepFinish = _ref8.onStepFinish, _ref8$maxSteps = _ref8.maxSteps, maxSteps = _ref8$maxSteps === void 0 ? 5 : _ref8$maxSteps, threadIdInFn = _ref8.threadId, resourceid = _ref8.resourceid, runId = _ref8.runId;
            _this$__primitive = this.__primitive({
              messages: messages,
              context: context,
              threadId: threadIdInFn,
              resourceid: resourceid,
              runId: runId
            }), before = _this$__primitive.before, after = _this$__primitive.after;
            _context9.next = 4;
            return before();
          case 4:
            _yield$before = _context9.sent;
            threadId = _yield$before.threadId;
            messageObjects = _yield$before.messageObjects;
            convertedTools = _yield$before.convertedTools;
            _context9.next = 10;
            return this.llm.__text({
              messages: messageObjects,
              enabledTools: this.enabledTools,
              convertedTools: convertedTools,
              onStepFinish: onStepFinish,
              maxSteps: maxSteps,
              runId: runId
            });
          case 10:
            result = _context9.sent;
            _context9.next = 13;
            return after({
              result: result,
              threadId: threadId
            });
          case 13:
            return _context9.abrupt("return", result);
          case 14:
          case "end":
            return _context9.stop();
        }
      }, _callee9, this);
    }));
    function text(_x8) {
      return _text.apply(this, arguments);
    }
    return text;
  }();
  _proto.textObject = /*#__PURE__*/function () {
    var _textObject = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee10(_ref9) {
      var messages, context, structuredOutput, onStepFinish, _ref9$maxSteps, maxSteps, threadIdInFn, resourceid, runId, _this$__primitive2, before, after, _yield$before2, threadId, messageObjects, convertedTools, result;
      return _regeneratorRuntime().wrap(function _callee10$(_context10) {
        while (1) switch (_context10.prev = _context10.next) {
          case 0:
            messages = _ref9.messages, context = _ref9.context, structuredOutput = _ref9.structuredOutput, onStepFinish = _ref9.onStepFinish, _ref9$maxSteps = _ref9.maxSteps, maxSteps = _ref9$maxSteps === void 0 ? 5 : _ref9$maxSteps, threadIdInFn = _ref9.threadId, resourceid = _ref9.resourceid, runId = _ref9.runId;
            _this$__primitive2 = this.__primitive({
              messages: messages,
              context: context,
              threadId: threadIdInFn,
              resourceid: resourceid,
              runId: runId
            }), before = _this$__primitive2.before, after = _this$__primitive2.after;
            _context10.next = 4;
            return before();
          case 4:
            _yield$before2 = _context10.sent;
            threadId = _yield$before2.threadId;
            messageObjects = _yield$before2.messageObjects;
            convertedTools = _yield$before2.convertedTools;
            _context10.next = 10;
            return this.llm.__textObject({
              messages: messageObjects,
              structuredOutput: structuredOutput,
              enabledTools: this.enabledTools,
              convertedTools: convertedTools,
              onStepFinish: onStepFinish,
              maxSteps: maxSteps,
              runId: runId
            });
          case 10:
            result = _context10.sent;
            _context10.next = 13;
            return after({
              result: result,
              threadId: threadId
            });
          case 13:
            return _context10.abrupt("return", result);
          case 14:
          case "end":
            return _context10.stop();
        }
      }, _callee10, this);
    }));
    function textObject(_x9) {
      return _textObject.apply(this, arguments);
    }
    return textObject;
  }();
  _proto.stream = /*#__PURE__*/function () {
    var _stream = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee12(_ref10) {
      var messages, context, onStepFinish, _onFinish, _ref10$maxSteps, maxSteps, threadIdInFn, resourceid, runId, _this$__primitive3, before, after, _yield$before3, threadId, messageObjects, convertedTools;
      return _regeneratorRuntime().wrap(function _callee12$(_context12) {
        while (1) switch (_context12.prev = _context12.next) {
          case 0:
            messages = _ref10.messages, context = _ref10.context, onStepFinish = _ref10.onStepFinish, _onFinish = _ref10.onFinish, _ref10$maxSteps = _ref10.maxSteps, maxSteps = _ref10$maxSteps === void 0 ? 5 : _ref10$maxSteps, threadIdInFn = _ref10.threadId, resourceid = _ref10.resourceid, runId = _ref10.runId;
            _this$__primitive3 = this.__primitive({
              messages: messages,
              context: context,
              threadId: threadIdInFn,
              resourceid: resourceid,
              runId: runId
            }), before = _this$__primitive3.before, after = _this$__primitive3.after;
            _context12.next = 4;
            return before();
          case 4:
            _yield$before3 = _context12.sent;
            threadId = _yield$before3.threadId;
            messageObjects = _yield$before3.messageObjects;
            convertedTools = _yield$before3.convertedTools;
            console.log('start streaming in agent');
            return _context12.abrupt("return", this.llm.__stream({
              messages: messageObjects,
              enabledTools: this.enabledTools,
              convertedTools: convertedTools,
              onStepFinish: onStepFinish,
              onFinish: function () {
                var _onFinish2 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee11(result) {
                  var res;
                  return _regeneratorRuntime().wrap(function _callee11$(_context11) {
                    while (1) switch (_context11.prev = _context11.next) {
                      case 0:
                        _context11.prev = 0;
                        res = JSON.parse(result) || {};
                        _context11.next = 4;
                        return after({
                          result: res,
                          threadId: threadId
                        });
                      case 4:
                        _context11.next = 9;
                        break;
                      case 6:
                        _context11.prev = 6;
                        _context11.t0 = _context11["catch"](0);
                        console.error('Error saving memory on finish', _context11.t0);
                      case 9:
                        _onFinish == null || _onFinish(result);
                      case 10:
                      case "end":
                        return _context11.stop();
                    }
                  }, _callee11, null, [[0, 6]]);
                }));
                function onFinish(_x11) {
                  return _onFinish2.apply(this, arguments);
                }
                return onFinish;
              }(),
              maxSteps: maxSteps,
              runId: runId
            }));
          case 10:
          case "end":
            return _context12.stop();
        }
      }, _callee12, this);
    }));
    function stream(_x10) {
      return _stream.apply(this, arguments);
    }
    return stream;
  }();
  _proto.streamObject = /*#__PURE__*/function () {
    var _streamObject = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee14(_ref11) {
      var messages, context, structuredOutput, onStepFinish, _onFinish3, _ref11$maxSteps, maxSteps, threadIdInFn, resourceid, runId, _this$__primitive4, before, after, _yield$before4, threadId, messageObjects, convertedTools;
      return _regeneratorRuntime().wrap(function _callee14$(_context14) {
        while (1) switch (_context14.prev = _context14.next) {
          case 0:
            messages = _ref11.messages, context = _ref11.context, structuredOutput = _ref11.structuredOutput, onStepFinish = _ref11.onStepFinish, _onFinish3 = _ref11.onFinish, _ref11$maxSteps = _ref11.maxSteps, maxSteps = _ref11$maxSteps === void 0 ? 5 : _ref11$maxSteps, threadIdInFn = _ref11.threadId, resourceid = _ref11.resourceid, runId = _ref11.runId;
            _this$__primitive4 = this.__primitive({
              messages: messages,
              context: context,
              threadId: threadIdInFn,
              resourceid: resourceid,
              runId: runId
            }), before = _this$__primitive4.before, after = _this$__primitive4.after;
            _context14.next = 4;
            return before();
          case 4:
            _yield$before4 = _context14.sent;
            threadId = _yield$before4.threadId;
            messageObjects = _yield$before4.messageObjects;
            convertedTools = _yield$before4.convertedTools;
            return _context14.abrupt("return", this.llm.__streamObject({
              messages: messageObjects,
              structuredOutput: structuredOutput,
              enabledTools: this.enabledTools,
              convertedTools: convertedTools,
              onStepFinish: onStepFinish,
              onFinish: function () {
                var _onFinish4 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee13(result) {
                  var res;
                  return _regeneratorRuntime().wrap(function _callee13$(_context13) {
                    while (1) switch (_context13.prev = _context13.next) {
                      case 0:
                        _context13.prev = 0;
                        res = JSON.parse(result) || {};
                        _context13.next = 4;
                        return after({
                          result: res,
                          threadId: threadId
                        });
                      case 4:
                        _context13.next = 9;
                        break;
                      case 6:
                        _context13.prev = 6;
                        _context13.t0 = _context13["catch"](0);
                        console.error('Error saving memory on finish', _context13.t0);
                      case 9:
                        _onFinish3 == null || _onFinish3(result);
                      case 10:
                      case "end":
                        return _context13.stop();
                    }
                  }, _callee13, null, [[0, 6]]);
                }));
                function onFinish(_x13) {
                  return _onFinish4.apply(this, arguments);
                }
                return onFinish;
              }(),
              maxSteps: maxSteps,
              runId: runId
            }));
          case 9:
          case "end":
            return _context14.stop();
        }
      }, _callee14, this);
    }));
    function streamObject(_x12) {
      return _streamObject.apply(this, arguments);
    }
    return streamObject;
  }();
  return Agent;
}());
function _log2$1(level, message, runId) {
  var _classPrivateFieldLoo, _classPrivateFieldLoo2;
  if (!_classPrivateFieldLooseBase(this, _logger$1)[_logger$1]) return;
  var logMessage = {
    type: RegisteredLogger.AGENT,
    message: message,
    destinationPath: 'AGENT',
    runId: runId
  };
  var logMethod = level.toLowerCase();
  (_classPrivateFieldLoo = (_classPrivateFieldLoo2 = _classPrivateFieldLooseBase(this, _logger$1)[_logger$1])[logMethod]) == null || _classPrivateFieldLoo.call(_classPrivateFieldLoo2, logMessage);
}
Agent = /*#__PURE__*/__decorate([/*#__PURE__*/InstrumentClass({
  prefix: 'agent',
  excludeMethods: ['__setTools', '__setLogger', '__setTelemetry', '#log']
}), /*#__PURE__*/__metadata("design:paramtypes", [Object])], Agent);

function createTool(opts) {
  return opts;
}

var _excluded = ["client"];
var Integration = /*#__PURE__*/function () {
  function Integration() {
    this.authType = 'API_KEY';
  }
  var _proto = Integration.prototype;
  _proto.getApiClient = /*#__PURE__*/function () {
    var _getApiClient = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            throw new Error('API not implemented');
          case 1:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }));
    function getApiClient() {
      return _getApiClient.apply(this, arguments);
    }
    return getApiClient;
  }();
  _proto._generateIntegrationTools = function _generateIntegrationTools() {
    var _this = this;
    var _this$baseClient = this.baseClient,
      clientMethods = _objectWithoutPropertiesLoose(_this$baseClient, _excluded);
    var schemas = this.toolSchemas;
    var documentations = this.toolDocumentations;
    var tools = Object.keys(clientMethods).reduce(function (acc, key) {
      var _documentations$key, _documentations$key2, _extends2;
      var comment = (_documentations$key = documentations[key]) == null ? void 0 : _documentations$key.comment;
      var doc = (_documentations$key2 = documentations[key]) == null ? void 0 : _documentations$key2.doc;
      var fallbackComment = "Execute " + key;
      var tool = createTool({
        label: key,
        schema: schemas[key] || z.object({}),
        description: comment || fallbackComment,
        documentation: doc || fallbackComment,
        executor: function () {
          var _executor = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref) {
            var data, client, value;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  data = _ref.data;
                  _context2.next = 3;
                  return _this.getApiClient();
                case 3:
                  client = _context2.sent;
                  value = client[key];
                  return _context2.abrupt("return", value(_extends({}, data)));
                case 6:
                case "end":
                  return _context2.stop();
              }
            }, _callee2);
          }));
          function executor(_x) {
            return _executor.apply(this, arguments);
          }
          return executor;
        }()
      });
      return _extends({}, acc, (_extends2 = {}, _extends2[key] = tool, _extends2));
    }, {});
    return tools;
  };
  return _createClass(Integration, [{
    key: "toolSchemas",
    get: function get() {
      return {};
    }
  }, {
    key: "toolDocumentations",
    get: function get() {
      return {};
    }
  }, {
    key: "baseClient",
    get: function get() {
      return {};
    }
  }]);
}();

var PropertyType;
(function (PropertyType) {
  PropertyType["LONG_TEXT"] = "LONG_TEXT";
  PropertyType["SINGLE_LINE_TEXT"] = "SINGLE_LINE_TEXT";
  PropertyType["SINGLE_SELECT"] = "SINGLE_SELECT";
  PropertyType["MULTI_SELECT"] = "MULTI_SELECT";
  PropertyType["CHECKBOX"] = "CHECKBOX";
  PropertyType["DATE"] = "DATE";
  PropertyType["USER"] = "USER";
  PropertyType["BADGE_LIST"] = "BADGE_LIST";
  PropertyType["CURRENCY"] = "CURRENCY";
  PropertyType["URL"] = "URL";
  PropertyType["PHONE"] = "PHONE";
  PropertyType["CONTACT"] = "CONTACT";
  PropertyType["COMPANY"] = "COMPANY";
  PropertyType["PERSON"] = "PERSON";
  PropertyType["ENRICHMENT"] = "ENRICHMENT";
  PropertyType["COMPOSITE"] = "COMPOSITE";
  PropertyType["BOOLEAN"] = "BOOLEAN";
  PropertyType["NUMBER"] = "NUMBER";
  PropertyType["FLOAT"] = "FLOAT";
  PropertyType["JSON_OBJECT"] = "JSON_OBJECT";
  PropertyType["JSON_ARRAY"] = "JSON_ARRAY";
})(PropertyType || (PropertyType = {}));
var FilterOperators;
(function (FilterOperators) {
  FilterOperators["IS"] = "is";
  FilterOperators["EQUAL"] = "eq";
  FilterOperators["NOT_EQUAL"] = "not_eq";
  FilterOperators["CONTAINS"] = "contains";
  FilterOperators["IN"] = "in";
  FilterOperators["NOT_IN"] = "not_in";
  FilterOperators["GREATER_THAN"] = "gt";
  FilterOperators["LESS_THAN"] = "lt";
  FilterOperators["NOT_CONTAINS"] = "not_contains";
  FilterOperators["GREATER_THAN_OR_EQUAL"] = "gte";
  FilterOperators["LESS_THAN_OR_EQUAL"] = "lte";
  FilterOperators["OP"] = "op";
  FilterOperators["SET"] = "set";
  FilterOperators["NOT_SET"] = "not_set";
})(FilterOperators || (FilterOperators = {}));

var _telemetry$2 = /*#__PURE__*/_classPrivateFieldLooseKey("telemetry");
var MastraEngine = /*#__PURE__*/function () {
  /**
   * Initializes the database connection
   * @param config Configuration object for database connection
   */
  function MastraEngine(config) {
    Object.defineProperty(this, _telemetry$2, {
      writable: true,
      value: void 0
    });
    console.log('ci===', config);
  }
  /**
   * Set the telemetry on the engine
   * @param telemetry
   */
  var _proto = MastraEngine.prototype;
  _proto.__setTelemetry = function __setTelemetry(telemetry) {
    _classPrivateFieldLooseBase(this, _telemetry$2)[_telemetry$2] = telemetry;
    console.log(_classPrivateFieldLooseBase(this, _telemetry$2)[_telemetry$2].name + " set on engine");
  }
  /**
   * Get the telemetry on the engine
   * @returns telemetry
   */;
  _proto.__getTelemetry = function __getTelemetry() {
    return _classPrivateFieldLooseBase(this, _telemetry$2)[_telemetry$2];
  }
  // Add protected method to access telemetry
  ;
  _proto.getTelemetry = function getTelemetry() {
    return _classPrivateFieldLooseBase(this, _telemetry$2)[_telemetry$2];
  };
  return MastraEngine;
}();

var _telemetry$1 = /*#__PURE__*/_classPrivateFieldLooseKey("telemetry");
var MastraVector = /*#__PURE__*/function () {
  function MastraVector() {
    Object.defineProperty(this, _telemetry$1, {
      writable: true,
      value: void 0
    });
  }
  var _proto = MastraVector.prototype;
  /**
   * Set the telemetry on the vector
   * @param telemetry
   */
  _proto.__setTelemetry = function __setTelemetry(telemetry) {
    _classPrivateFieldLooseBase(this, _telemetry$1)[_telemetry$1] = telemetry;
    console.log(_classPrivateFieldLooseBase(this, _telemetry$1)[_telemetry$1].name + " set on vector");
  }
  /**
   * Get the telemetry on the vector
   * @returns telemetry
   */;
  _proto.__getTelemetry = function __getTelemetry() {
    return _classPrivateFieldLooseBase(this, _telemetry$1)[_telemetry$1];
  };
  return MastraVector;
}();

function createSync(opts) {
  return opts;
}

var Mastra = /*#__PURE__*/function () {
  function Mastra(config) {
    var _this = this,
      _config$integrations,
      _config$integrations2,
      _config$agents;
    this.engine = void 0;
    this.vectors = void 0;
    this.tools = void 0;
    this.agents = void 0;
    this.integrations = void 0;
    this.logger = void 0;
    this.syncs = void 0;
    this.telemetry = void 0;
    this.memory = void 0;
    /*
    Logger
    */
    var logger = createLogger({
      type: 'CONSOLE'
    });
    if (config.logger) {
      logger = config.logger;
    }
    this.logger = logger;
    /*
    Telemetry
    */
    if (config.telemetry) {
      this.telemetry = Telemetry.init(config.telemetry);
    }
    /*
    Engine
    */
    if (config.engine) {
      if (this.telemetry) {
        this.engine = this.telemetry.traceClass(config.engine, {
          excludeMethods: ['__setTelemetry', '__getTelemetry']
        });
        this.engine.__setTelemetry(this.telemetry);
      } else {
        this.engine = config.engine;
      }
    }
    /*
    Vectors
    */
    if (config.vectors) {
      var vectors = {};
      Object.entries(config.vectors).forEach(function (_ref) {
        var key = _ref[0],
          vector = _ref[1];
        if (_this.telemetry) {
          vectors[key] = _this.telemetry.traceClass(vector, {
            excludeMethods: ['__setTelemetry', '__getTelemetry']
          });
          vectors[key].__setTelemetry(_this.telemetry);
        } else {
          vectors[key] = vector;
        }
      });
      this.vectors = vectors;
    }
    /*
    Integrations
    */
    this.integrations = new Map();
    (_config$integrations = config.integrations) == null || _config$integrations.forEach(function (integration) {
      if (_this.integrations.has(integration.name)) {
        throw new Error("Integration with name " + integration.name + " already exists");
      }
      if (_this.telemetry) {
        _this.integrations.set(integration.name, _this.telemetry.traceClass(integration));
      } else {
        _this.integrations.set(integration.name, integration);
      }
    });
    /*
    Tools
    */
    var integrationTools = ((_config$integrations2 = config.integrations) == null ? void 0 : _config$integrations2.reduce(function (acc, integration) {
      return _extends({}, acc, integration.tools);
    }, {})) || {};
    var configuredTools = (config == null ? void 0 : config.tools) || {};
    var allTools = _extends({}, configuredTools, integrationTools);
    // Hydrate tools with traced integration registry
    var hydratedTools = Object.entries(allTools != null ? allTools : {}).reduce(function (memo, _ref2) {
      var key = _ref2[0],
        val = _ref2[1];
      var hydratedExecutor = function hydratedExecutor(params) {
        return val.executor(_extends({}, params, {
          integrationsRegistry: function integrationsRegistry() {
            return {
              get: function get(name) {
                return _this.getIntegration(name);
              }
            };
          },
          agents: _this.agents,
          llm: _this.LLM,
          engine: _this.engine,
          vectors: _this.vectors
        }));
      };
      memo[key] = _extends({}, val, {
        executor: _this.telemetry ? _this.telemetry.traceMethod(hydratedExecutor, {
          spanName: "tool." + key,
          attributes: {
            toolName: key
          }
        }) : hydratedExecutor
      });
      return memo;
    }, {});
    this.tools = hydratedTools;
    /*
    Syncs
    */
    if (config.syncs && !config.engine) {
      throw new Error('Engine is required to run syncs');
    }
    this.syncs = config.syncs || {};
    /*
    Agents
    */
    this.agents = new Map();
    (_config$agents = config.agents) == null || _config$agents.forEach(function (agent) {
      if (_this.agents.has(agent.name)) {
        throw new Error("Agent with name " + agent.name + " already exists");
      }
      _this.agents.set(agent.name, agent);
      agent.__setTools(_this.tools);
      if (_this.telemetry) {
        agent.__setTelemetry(_this.telemetry);
      }
      agent.__setLogger(_this.getLogger());
      if (config.memory) {
        agent.__setMemory(config.memory);
      }
    });
    if (config.syncs && !config.engine) {
      throw new Error('Engine is required to run syncs');
    }
    this.syncs = config.syncs || {};
    if (config.engine) {
      this.engine = config.engine;
    }
    if (config.vectors) {
      this.vectors = config.vectors;
    }
    this.memory = config.memory;
  }
  var _proto = Mastra.prototype;
  _proto.LLM = function LLM$1(modelConfig) {
    var llm = new LLM({
      model: modelConfig
    });
    llm.__setTools(this.tools);
    if (this.telemetry) {
      llm.__setTelemetry(this.telemetry);
    }
    llm.__setLogger(this.getLogger());
    return llm;
  };
  _proto.sync = /*#__PURE__*/function () {
    var _sync = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(key, params, runId) {
      var _this$syncs,
        _this2 = this;
      var sync, syncFn;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (this.engine) {
              _context.next = 2;
              break;
            }
            throw new Error("Engine is required to run syncs");
          case 2:
            sync = (_this$syncs = this.syncs) == null ? void 0 : _this$syncs[key];
            if (sync) {
              _context.next = 5;
              break;
            }
            throw new Error("Sync function " + key + " not found");
          case 5:
            syncFn = sync['executor'];
            if (syncFn) {
              _context.next = 8;
              break;
            }
            throw new Error("Sync function " + key + " not found");
          case 8:
            _context.next = 10;
            return syncFn({
              data: params,
              runId: runId,
              engine: this.engine,
              agents: this.agents,
              vectors: this.vectors,
              llm: this.LLM,
              integrationsRegistry: function integrationsRegistry() {
                return {
                  get: function get(name) {
                    return _this2.getIntegration(name);
                  }
                };
              },
              toolsRegistry: function toolsRegistry() {
                return {
                  get: function get(name) {
                    return _this2.getTool(name);
                  }
                };
              }
            });
          case 10:
            return _context.abrupt("return", _context.sent);
          case 11:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function sync(_x, _x2, _x3) {
      return _sync.apply(this, arguments);
    }
    return sync;
  }();
  _proto.getAgent = function getAgent(name) {
    var agent = this.agents.get(name);
    if (!agent) {
      throw new Error("Agent with name " + name + " not found");
    }
    return agent;
  };
  _proto.getIntegration = function getIntegration(name) {
    var stringifiedName = String(name);
    var integration = this.integrations.get(stringifiedName.toUpperCase());
    if (!integration) {
      throw new Error("Integration with name " + stringifiedName + " not found");
    }
    return integration;
  };
  _proto.getTool = function getTool(name) {
    var _this3 = this;
    var tools = this.tools;
    var tool = tools[name];
    if (!tool) {
      throw new Error("Tool with name " + String(name) + " not found");
    }
    var hydratedExecutor = /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(params, runId) {
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              return _context2.abrupt("return", tool.executor({
                data: params,
                runId: runId,
                integrationsRegistry: function integrationsRegistry() {
                  return {
                    get: function get(name) {
                      return _this3.getIntegration(name);
                    }
                  };
                },
                agents: _this3.agents,
                llm: _this3.LLM,
                engine: _this3.engine,
                vectors: _this3.vectors
              }));
            case 1:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }));
      return function hydratedExecutor(_x4, _x5) {
        return _ref3.apply(this, arguments);
      };
    }();
    return _extends({}, tool, {
      execute: this.telemetry ? this.telemetry.traceMethod(hydratedExecutor, {
        spanName: "tool." + String(name),
        attributes: {
          toolName: String(name)
        }
      }) : hydratedExecutor
    });
  };
  _proto.availableIntegrations = function availableIntegrations() {
    return Array.from(this.integrations.entries()).map(function (_ref4) {
      var name = _ref4[0],
        integration = _ref4[1];
      return {
        name: name,
        integration: integration
      };
    });
  };
  _proto.getTools = function getTools() {
    return this.tools;
  };
  _proto.setLogger = function setLogger(_ref5) {
    var logger = _ref5.logger;
    this.logger = logger;
  };
  _proto.getLogger = function getLogger() {
    return this.logger;
  };
  _proto.getTelemetry = function getTelemetry() {
    return this.telemetry;
  };
  _proto.getLogsByRunId = /*#__PURE__*/function () {
    var _getLogsByRunId = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3(runId) {
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return this.logger.getLogsByRunId(runId);
          case 2:
            return _context3.abrupt("return", _context3.sent);
          case 3:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this);
    }));
    function getLogsByRunId(_x6) {
      return _getLogsByRunId.apply(this, arguments);
    }
    return getLogsByRunId;
  }();
  return Mastra;
}();
Mastra = /*#__PURE__*/__decorate([/*#__PURE__*/InstrumentClass({
  prefix: 'mastra',
  excludeMethods: ['getLogger', 'getTelemetry']
}), /*#__PURE__*/__metadata("design:paramtypes", [Object])], Mastra);

function isErrorEvent(stateEvent) {
  return stateEvent.type.startsWith('xstate.error.actor.');
}
function isTransitionEvent(stateEvent) {
  return stateEvent.type.startsWith('xstate.done.actor.');
}
function isVariableReference(value) {
  return typeof value === 'object' && 'stepId' in value && 'path' in value;
}
function getStepResult(result) {
  if ((result == null ? void 0 : result.status) === 'success') return result.payload;
  return undefined;
}

var _logger = /*#__PURE__*/_classPrivateFieldLooseKey("logger");
var _triggerSchema = /*#__PURE__*/_classPrivateFieldLooseKey("triggerSchema");
var _steps = /*#__PURE__*/_classPrivateFieldLooseKey("steps");
var _stepConfiguration = /*#__PURE__*/_classPrivateFieldLooseKey("stepConfiguration");
var _machine = /*#__PURE__*/_classPrivateFieldLooseKey("machine");
var _actor = /*#__PURE__*/_classPrivateFieldLooseKey("actor");
var _runId = /*#__PURE__*/_classPrivateFieldLooseKey("runId");
var _retryConfig = /*#__PURE__*/_classPrivateFieldLooseKey("retryConfig");
var _telemetry = /*#__PURE__*/_classPrivateFieldLooseKey("telemetry");
var _buildStateHierarchy = /*#__PURE__*/_classPrivateFieldLooseKey("buildStateHierarchy");
var _resolveVariables = /*#__PURE__*/_classPrivateFieldLooseKey("resolveVariables");
var _evaluateCondition = /*#__PURE__*/_classPrivateFieldLooseKey("evaluateCondition");
var _log = /*#__PURE__*/_classPrivateFieldLooseKey("log");
var _makeStepDef = /*#__PURE__*/_classPrivateFieldLooseKey("makeStepDef");
var _makeDelayMap = /*#__PURE__*/_classPrivateFieldLooseKey("makeDelayMap");
var _cleanup = /*#__PURE__*/_classPrivateFieldLooseKey("cleanup");
var Workflow = /*#__PURE__*/function () {
  /**
   * Creates a new Workflow instance
   * @param name - Identifier for the workflow (not necessarily unique)
   * @param logger - Optional logger instance
   */
  function Workflow(_ref) {
    var _this = this;
    var name = _ref.name,
      steps = _ref.steps,
      logger = _ref.logger,
      triggerSchema = _ref.triggerSchema,
      retryConfig = _ref.retryConfig,
      telemetry = _ref.telemetry;
    /**
     * Cleans up the actor instance
     */
    Object.defineProperty(this, _cleanup, {
      value: _cleanup2
    });
    /**
     * Creates a map of step IDs to their respective delay values
     * @returns Object mapping step IDs to delay values
     */
    Object.defineProperty(this, _makeDelayMap, {
      value: _makeDelayMap2
    });
    Object.defineProperty(this, _makeStepDef, {
      value: _makeStepDef2
    });
    /**
     * Internal logging helper that formats and sends logs to the configured logger
     * @param level - Severity level of the log
     * @param message - Main log message
     * @param data - Optional data to include in the log
     * @param stepId - Optional ID of the step that generated the log
     */
    Object.defineProperty(this, _log, {
      value: _log2
    });
    /**
     * Evaluates a single condition against workflow context
     */
    Object.defineProperty(this, _evaluateCondition, {
      value: _evaluateCondition2
    });
    /**
     * Resolves variables for a step from trigger data or previous step results
     * @param stepConfig - Configuration of the step needing variable resolution
     * @param context - Current workflow context containing results and trigger data
     * @returns Object containing resolved variable values
     */
    Object.defineProperty(this, _resolveVariables, {
      value: _resolveVariables2
    });
    /**
     * Builds the state hierarchy for the workflow
     * @returns Object representing the state hierarchy
     */
    Object.defineProperty(this, _buildStateHierarchy, {
      value: _buildStateHierarchy2
    });
    this.name = void 0;
    Object.defineProperty(this, _logger, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _triggerSchema, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _steps, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _stepConfiguration, {
      writable: true,
      value: {}
    });
    /** XState machine instance that orchestrates the workflow execution */
    Object.defineProperty(this, _machine, {
      writable: true,
      value: void 0
    });
    /** XState actor instance that manages the workflow execution */
    Object.defineProperty(this, _actor, {
      writable: true,
      value: null
    });
    Object.defineProperty(this, _runId, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _retryConfig, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _telemetry, {
      writable: true,
      value: void 0
    });
    this.name = name;
    _classPrivateFieldLooseBase(this, _logger)[_logger] = logger;
    _classPrivateFieldLooseBase(this, _steps)[_steps] = steps;
    _classPrivateFieldLooseBase(this, _retryConfig)[_retryConfig] = retryConfig || {
      attempts: 3,
      delay: 1000
    };
    _classPrivateFieldLooseBase(this, _triggerSchema)[_triggerSchema] = triggerSchema;
    _classPrivateFieldLooseBase(this, _runId)[_runId] = crypto.randomUUID();
    _classPrivateFieldLooseBase(this, _telemetry)[_telemetry] = telemetry;
    this.initializeMachine();
    // Initialize step definitions
    steps.forEach(function (step) {
      _classPrivateFieldLooseBase(_this, _stepConfiguration)[_stepConfiguration][step.id] = _extends({}, _classPrivateFieldLooseBase(_this, _makeStepDef)[_makeStepDef](step.id));
    });
  }
  /**
   * Initializes the XState machine for the workflow
   *
   * Registers the machine's types, actions, actors, initial context, entry actions, initial state, and states
   * @returns The initialized machine
   */
  var _proto = Workflow.prototype;
  _proto.initializeMachine = function initializeMachine() {
    var _this2 = this;
    var machine = setup({
      types: {},
      delays: _classPrivateFieldLooseBase(this, _makeDelayMap)[_makeDelayMap](),
      actions: {
        updateStepResult: assign({
          stepResults: function stepResults(_ref2) {
            var _extends2;
            var context = _ref2.context,
              event = _ref2.event;
            if (!isTransitionEvent(event)) return context.stepResults;
            var _event$output = event.output,
              stepId = _event$output.stepId,
              result = _event$output.result;
            return _extends({}, context.stepResults, (_extends2 = {}, _extends2[stepId] = {
              status: 'success',
              payload: result
            }, _extends2));
          }
        }),
        setStepError: assign({
          stepResults: function stepResults(_ref3, params) {
            var _extends3;
            var context = _ref3.context,
              event = _ref3.event;
            if (!isErrorEvent(event)) return context.stepResults;
            var stepId = params.stepId;
            if (!stepId) return context.stepResults;
            return _extends({}, context.stepResults, (_extends3 = {}, _extends3[stepId] = {
              status: 'failed',
              error: event.error.message
            }, _extends3));
          }
        }),
        notifyStepCompletion: function notifyStepCompletion(_, params) {
          var stepId = params.stepId;
          _classPrivateFieldLooseBase(_this2, _log)[_log](LogLevel.INFO, "Step " + stepId + " completed");
        },
        decrementAttemptCount: assign({
          attempts: function attempts(_ref4, params) {
            var _extends4;
            var context = _ref4.context,
              event = _ref4.event;
            if (!isTransitionEvent(event)) return context.attempts;
            var stepId = params.stepId;
            var attemptCount = context.attempts[stepId];
            if (attemptCount === undefined) return context.attempts;
            return _extends({}, context.attempts, (_extends4 = {}, _extends4[stepId] = attemptCount - 1, _extends4));
          }
        })
      },
      actors: {
        resolverFunction: fromPromise(/*#__PURE__*/function () {
          var _ref6 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref5) {
            var input, step, context, stepId, resolvedData, result;
            return _regeneratorRuntime().wrap(function _callee$(_context) {
              while (1) switch (_context.prev = _context.next) {
                case 0:
                  input = _ref5.input;
                  step = input.step, context = input.context, stepId = input.stepId;
                  resolvedData = _classPrivateFieldLooseBase(_this2, _resolveVariables)[_resolveVariables]({
                    stepConfig: step,
                    context: context
                  });
                  _context.next = 5;
                  return step == null ? void 0 : step.handler({
                    data: resolvedData,
                    runId: _classPrivateFieldLooseBase(_this2, _runId)[_runId]
                  });
                case 5:
                  result = _context.sent;
                  return _context.abrupt("return", {
                    stepId: stepId,
                    result: result
                  });
                case 7:
                case "end":
                  return _context.stop();
              }
            }, _callee);
          }));
          return function (_x) {
            return _ref6.apply(this, arguments);
          };
        }()),
        dependencyCheck: fromPromise(/*#__PURE__*/function () {
          var _ref8 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref7) {
            var input, context, stepId, step, attemptCount, missingDeps, failedDeps, conditionMet, _conditionMet;
            return _regeneratorRuntime().wrap(function _callee2$(_context2) {
              while (1) switch (_context2.prev = _context2.next) {
                case 0:
                  input = _ref7.input;
                  context = input.context, stepId = input.stepId;
                  step = _classPrivateFieldLooseBase(_this2, _stepConfiguration)[_stepConfiguration][stepId];
                  attemptCount = context.attempts[stepId];
                  if (!(!attemptCount || attemptCount < 0)) {
                    _context2.next = 6;
                    break;
                  }
                  return _context2.abrupt("return", {
                    type: 'TIMED_OUT',
                    error: "Step:" + stepId + " timed out"
                  });
                case 6:
                  // Check dependencies are present and valid
                  missingDeps = step == null ? void 0 : step.dependsOn.filter(function (depId) {
                    return !(depId in context.stepResults);
                  });
                  if (!(missingDeps != null && missingDeps.length && missingDeps.length > 0)) {
                    _context2.next = 9;
                    break;
                  }
                  return _context2.abrupt("return", {
                    type: 'DEPENDENCIES_NOT_MET'
                  });
                case 9:
                  failedDeps = step == null ? void 0 : step.dependsOn.filter(function (depId) {
                    var _context$stepResults$, _context$stepResults$2;
                    return ((_context$stepResults$ = context.stepResults[depId]) == null ? void 0 : _context$stepResults$.status) === 'failed' || ((_context$stepResults$2 = context.stepResults[depId]) == null ? void 0 : _context$stepResults$2.status) === 'skipped';
                  });
                  if (!(failedDeps != null && failedDeps.length && failedDeps.length > 0)) {
                    _context2.next = 12;
                    break;
                  }
                  return _context2.abrupt("return", {
                    type: 'SKIP_STEP',
                    missingDeps: failedDeps
                  });
                case 12:
                  if (!(step != null && step.condition)) {
                    _context2.next = 16;
                    break;
                  }
                  conditionMet = _classPrivateFieldLooseBase(_this2, _evaluateCondition)[_evaluateCondition](step.condition, context);
                  if (conditionMet) {
                    _context2.next = 16;
                    break;
                  }
                  return _context2.abrupt("return", {
                    type: 'CONDITION_FAILED',
                    error: "Step:" + stepId + " condition check failed"
                  });
                case 16:
                  if (!(step != null && step.conditionFn)) {
                    _context2.next = 22;
                    break;
                  }
                  _context2.next = 19;
                  return step.conditionFn({
                    context: context
                  });
                case 19:
                  _conditionMet = _context2.sent;
                  if (_conditionMet) {
                    _context2.next = 22;
                    break;
                  }
                  return _context2.abrupt("return", {
                    type: 'CONDITION_FAILED',
                    error: "Step:" + stepId + " condition function check failed"
                  });
                case 22:
                  return _context2.abrupt("return", {
                    type: 'DEPENDENCIES_MET'
                  });
                case 23:
                case "end":
                  return _context2.stop();
              }
            }, _callee2);
          }));
          return function (_x2) {
            return _ref8.apply(this, arguments);
          };
        }())
      }
    }).createMachine({
      id: this.name,
      type: 'parallel',
      context: function context(_ref9) {
        var input = _ref9.input;
        return _extends({}, input);
      },
      states: _classPrivateFieldLooseBase(this, _buildStateHierarchy)[_buildStateHierarchy]()
    });
    _classPrivateFieldLooseBase(this, _machine)[_machine] = machine;
    return machine;
  }
  /**
   * Configures a step in the workflow
   * @param id - Unique identifier for the step
   * @param config - Step configuration including handler, schema, variables, and payload
   * @returns this instance for method chaining
   */;
  _proto.config = function config(id, _config) {
    var _config$variables = _config.variables,
      variables = _config$variables === void 0 ? {} : _config$variables,
      dependsOn = _config.dependsOn,
      condition = _config.condition,
      conditionFn = _config.conditionFn;
    var requiredData = {};
    // Add valid variables to requiredData
    for (var _i = 0, _Object$entries = Object.entries(variables); _i < _Object$entries.length; _i++) {
      var _Object$entries$_i = _Object$entries[_i],
        key = _Object$entries$_i[0],
        variable = _Object$entries$_i[1];
      if (variable && isVariableReference(variable)) {
        requiredData[key] = variable;
      }
    }
    _classPrivateFieldLooseBase(this, _stepConfiguration)[_stepConfiguration][id] = _extends({}, _classPrivateFieldLooseBase(this, _makeStepDef)[_makeStepDef](id), {
      dependsOn: dependsOn,
      condition: condition,
      conditionFn: conditionFn,
      data: requiredData
    });
    return this;
  }
  /**
   * Executes the workflow with the given trigger data
   * @param triggerData - Initial data to start the workflow with
   * @returns Promise resolving to workflow results or rejecting with error
   * @throws Error if trigger schema validation fails
   */;
  _proto.execute =
  /*#__PURE__*/
  function () {
    var _execute = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee3(triggerData) {
      var _this3 = this;
      return _regeneratorRuntime().wrap(function _callee3$(_context3) {
        while (1) switch (_context3.prev = _context3.next) {
          case 0:
            _classPrivateFieldLooseBase(this, _runId)[_runId] = crypto.randomUUID();
            _context3.next = 3;
            return _classPrivateFieldLooseBase(this, _log)[_log](LogLevel.INFO, 'Executing workflow', {
              triggerData: triggerData
            });
          case 3:
            if (!_classPrivateFieldLooseBase(this, _triggerSchema)[_triggerSchema]) {
              _context3.next = 15;
              break;
            }
            _context3.prev = 4;
            _classPrivateFieldLooseBase(this, _triggerSchema)[_triggerSchema].parse(triggerData);
            _context3.next = 8;
            return _classPrivateFieldLooseBase(this, _log)[_log](LogLevel.DEBUG, 'Trigger schema validation passed');
          case 8:
            _context3.next = 15;
            break;
          case 10:
            _context3.prev = 10;
            _context3.t0 = _context3["catch"](4);
            _context3.next = 14;
            return _classPrivateFieldLooseBase(this, _log)[_log](LogLevel.ERROR, 'Trigger schema validation failed', {
              error: _context3.t0
            });
          case 14:
            throw _context3.t0;
          case 15:
            _classPrivateFieldLooseBase(this, _actor)[_actor] = createActor(_classPrivateFieldLooseBase(this, _machine)[_machine], {
              input: {
                stepResults: {},
                triggerData: triggerData || {},
                attempts: _classPrivateFieldLooseBase(this, _steps)[_steps].reduce(function (acc, step) {
                  var _step$retryConfig, _classPrivateFieldLoo;
                  acc[step.id] = ((_step$retryConfig = step.retryConfig) == null ? void 0 : _step$retryConfig.attempts) || ((_classPrivateFieldLoo = _classPrivateFieldLooseBase(_this3, _retryConfig)[_retryConfig]) == null ? void 0 : _classPrivateFieldLoo.attempts) || 3;
                  return acc;
                }, {})
              }
            });
            _classPrivateFieldLooseBase(this, _actor)[_actor].start();
            return _context3.abrupt("return", new Promise(function (resolve, reject) {
              if (!_classPrivateFieldLooseBase(_this3, _actor)[_actor]) {
                reject(new Error('Actor not initialized'));
                return;
              }
              _classPrivateFieldLooseBase(_this3, _actor)[_actor].subscribe(function (state) {
                // Check if all parallel states are in a final state
                var allStatesValue = state.value;
                var allStatesComplete = Object.values(allStatesValue).every(function (value) {
                  return ['completed', 'failed', 'skipped'].includes(value);
                });
                if (allStatesComplete) {
                  // Check if any steps failed
                  var hasFailures = Object.values(state.context.stepResults).some(function (result) {
                    return result.status === 'failed';
                  });
                  if (hasFailures) {
                    _classPrivateFieldLooseBase(_this3, _log)[_log](LogLevel.ERROR, 'Workflow failed', {
                      results: state.context.stepResults
                    });
                    _classPrivateFieldLooseBase(_this3, _cleanup)[_cleanup]();
                    resolve({
                      triggerData: triggerData,
                      results: state.context.stepResults,
                      runId: _classPrivateFieldLooseBase(_this3, _runId)[_runId]
                    });
                  } else {
                    _classPrivateFieldLooseBase(_this3, _log)[_log](LogLevel.INFO, 'Workflow completed', {
                      results: state.context.stepResults
                    });
                    _classPrivateFieldLooseBase(_this3, _cleanup)[_cleanup]();
                    resolve({
                      triggerData: triggerData,
                      results: state.context.stepResults,
                      runId: _classPrivateFieldLooseBase(_this3, _runId)[_runId]
                    });
                  }
                }
              });
            }));
          case 18:
          case "end":
            return _context3.stop();
        }
      }, _callee3, this, [[4, 10]]);
    }));
    function execute(_x3) {
      return _execute.apply(this, arguments);
    }
    return execute;
  }()
  /**
   * Rebuilds the machine with the current steps configuration and validates the workflow
   *
   * This is the last step of a workflow builder method chain
   * @throws Error if validation fails
   *
   * @returns this instance for method chaining
   */
  ;
  _proto.commit = function commit() {
    // this.#validateWorkflow();
    this.initializeMachine();
    return this;
  };
  return Workflow;
}();
function _buildStateHierarchy2() {
  var _this4 = this;
  var states = {};
  _classPrivateFieldLooseBase(this, _steps)[_steps].forEach(function (step) {
    var _after;
    states[step.id] = {
      initial: 'pending',
      states: {
        pending: {
          invoke: {
            src: 'dependencyCheck',
            input: function input(_ref10) {
              var context = _ref10.context;
              return {
                context: context,
                stepId: step.id
              };
            },
            onDone: [{
              guard: function guard(_ref11) {
                var event = _ref11.event;
                return event.output.type === 'DEPENDENCIES_MET';
              },
              target: 'executing'
            }, {
              guard: function guard(_ref12) {
                var event = _ref12.event;
                return event.output.type === 'DEPENDENCIES_NOT_MET';
              },
              target: 'waiting',
              actions: [{
                type: 'decrementAttemptCount',
                params: {
                  stepId: step.id
                }
              }]
            }, {
              guard: function guard(_ref13) {
                var event = _ref13.event;
                return event.output.type === 'SKIP_STEP';
              },
              target: 'skipped',
              actions: assign({
                stepResults: function stepResults(_ref14) {
                  var _extends5;
                  var context = _ref14.context,
                    event = _ref14.event;
                  if (event.output.type !== 'SKIP_STEP') return context.stepResults;
                  return _extends({}, context.stepResults, (_extends5 = {}, _extends5[step.id] = {
                    status: 'skipped',
                    missingDeps: event.output.missingDeps
                  }, _extends5));
                }
              })
            }, {
              guard: function guard(_ref15) {
                var event = _ref15.event;
                return event.output.type === 'TIMED_OUT';
              },
              target: 'failed',
              actions: assign({
                stepResults: function stepResults(_ref16) {
                  var _extends6;
                  var context = _ref16.context,
                    event = _ref16.event;
                  if (event.output.type !== 'TIMED_OUT') return context.stepResults;
                  _classPrivateFieldLooseBase(_this4, _log)[_log](LogLevel.ERROR, "Step:" + step.id + " timed out", {
                    error: event.output.error
                  });
                  return _extends({}, context.stepResults, (_extends6 = {}, _extends6[step.id] = {
                    status: 'failed',
                    error: event.output.error
                  }, _extends6));
                }
              })
            }, {
              guard: function guard(_ref17) {
                var event = _ref17.event;
                return event.output.type === 'CONDITION_FAILED';
              },
              target: 'failed',
              actions: assign({
                stepResults: function stepResults(_ref18) {
                  var _extends7;
                  var context = _ref18.context,
                    event = _ref18.event;
                  if (event.output.type !== 'CONDITION_FAILED') return context.stepResults;
                  _classPrivateFieldLooseBase(_this4, _log)[_log](LogLevel.ERROR, "workflow condition check failed", {
                    error: event.output.error,
                    stepId: step.id
                  });
                  return _extends({}, context.stepResults, (_extends7 = {}, _extends7[step.id] = {
                    status: 'failed',
                    error: event.output.error
                  }, _extends7));
                }
              })
            }]
          }
        },
        waiting: {
          entry: function entry() {
            _classPrivateFieldLooseBase(_this4, _log)[_log](LogLevel.INFO, "Step " + step.id + " waiting " + new Date().toISOString());
          },
          exit: function exit() {
            _classPrivateFieldLooseBase(_this4, _log)[_log](LogLevel.INFO, "Step " + step.id + " finished waiting " + new Date().toISOString());
          },
          after: (_after = {}, _after[step.id] = {
            target: 'pending'
          }, _after)
        },
        executing: {
          invoke: {
            src: 'resolverFunction',
            input: function input(_ref19) {
              var context = _ref19.context;
              return {
                context: context,
                stepId: step.id,
                step: _classPrivateFieldLooseBase(_this4, _stepConfiguration)[_stepConfiguration][step.id]
              };
            },
            onDone: {
              target: 'completed',
              actions: [{
                type: 'updateStepResult',
                params: {
                  stepId: step.id
                }
              }]
            },
            onError: {
              target: 'failed',
              actions: [{
                type: 'setStepError',
                params: {
                  stepId: step.id
                }
              }]
            }
          }
        },
        completed: {
          type: 'final',
          entry: [{
            type: 'notifyStepCompletion',
            params: {
              stepId: step.id
            }
          }]
        },
        failed: {
          type: 'final',
          entry: [{
            type: 'notifyStepCompletion',
            params: {
              stepId: step.id
            }
          }]
        },
        skipped: {
          type: 'final',
          entry: [{
            type: 'notifyStepCompletion',
            params: {
              stepId: step.id
            }
          }]
        }
      }
    };
  });
  return states;
}
function _resolveVariables2(_ref20) {
  var stepConfig = _ref20.stepConfig,
    context = _ref20.context;
  var resolvedData = {};
  for (var _i2 = 0, _Object$entries2 = Object.entries(stepConfig.data); _i2 < _Object$entries2.length; _i2++) {
    var _Object$entries2$_i = _Object$entries2[_i2],
      key = _Object$entries2$_i[0],
      variable = _Object$entries2$_i[1];
    // Check if variable comes from trigger data or a previous step's result
    var sourceData = variable.stepId === 'trigger' ? context.triggerData : getStepResult(context.stepResults[variable.stepId]);
    if (!sourceData && variable.stepId !== 'trigger') {
      resolvedData[key] = undefined;
      continue;
    }
    // If path is empty or '.', return the entire source data
    var value = variable.path === '' || variable.path === '.' ? sourceData[key] : get(sourceData, variable.path);
    resolvedData[key] = value;
  }
  return resolvedData;
}
function _evaluateCondition2(condition, context) {
  var _this5 = this;
  var andBranchResult = true;
  var baseResult = true;
  var orBranchResult = true;
  // Base condition
  if ('ref' in condition) {
    var ref = condition.ref,
      query = condition.query;
    var sourceData = ref.stepId === 'trigger' ? context.triggerData : getStepResult(context.stepResults[ref.stepId]);
    if (!sourceData) {
      return false;
    }
    var value = get(sourceData, ref.path);
    baseResult = sift(query)(value);
  }
  // AND condition
  if ('and' in condition) {
    andBranchResult = condition.and.every(function (cond) {
      return _classPrivateFieldLooseBase(_this5, _evaluateCondition)[_evaluateCondition](cond, context);
    });
  }
  // OR condition
  if ('or' in condition) {
    orBranchResult = condition.or.some(function (cond) {
      return _classPrivateFieldLooseBase(_this5, _evaluateCondition)[_evaluateCondition](cond, context);
    });
  }
  var finalResult = baseResult && andBranchResult && orBranchResult;
  return finalResult;
}
function _log2(_x4, _x5, _x6, _x7) {
  return _log3.apply(this, arguments);
}
function _log3() {
  _log3 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee5(level, message, data, stepId) {
    var _classPrivateFieldLoo3, _classPrivateFieldLoo4;
    var logMessage, logMethod;
    return _regeneratorRuntime().wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          if (_classPrivateFieldLooseBase(this, _logger)[_logger]) {
            _context5.next = 2;
            break;
          }
          return _context5.abrupt("return");
        case 2:
          logMessage = {
            type: RegisteredLogger.WORKFLOW,
            message: message,
            workflowName: this.name,
            destinationPath: "workflows/" + this.name,
            stepId: stepId,
            data: data,
            runId: _classPrivateFieldLooseBase(this, _runId)[_runId]
          };
          logMethod = level.toLowerCase();
          _context5.next = 6;
          return (_classPrivateFieldLoo3 = (_classPrivateFieldLoo4 = _classPrivateFieldLooseBase(this, _logger)[_logger])[logMethod]) == null ? void 0 : _classPrivateFieldLoo3.call(_classPrivateFieldLoo4, logMessage);
        case 6:
        case "end":
          return _context5.stop();
      }
    }, _callee5, this);
  }));
  return _log3.apply(this, arguments);
}
function _makeStepDef2(stepId) {
  var _this6 = this;
  var handler = /*#__PURE__*/function () {
    var _ref22 = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee4(_ref21) {
      var data, runId, targetStep, inputSchema, payload, action, mergedData, validatedData, finalAction;
      return _regeneratorRuntime().wrap(function _callee4$(_context4) {
        while (1) switch (_context4.prev = _context4.next) {
          case 0:
            data = _ref21.data, runId = _ref21.runId;
            targetStep = _classPrivateFieldLooseBase(_this6, _steps)[_steps].find(function (s) {
              return s.id === stepId;
            });
            if (targetStep) {
              _context4.next = 4;
              break;
            }
            throw new Error("Step not found");
          case 4:
            inputSchema = targetStep.inputSchema, payload = targetStep.payload, action = targetStep.action; // Merge static payload with dynamically resolved variables
            // Variables take precedence over payload values
            mergedData = _extends({}, payload, data); // Validate complete input data
            validatedData = inputSchema ? inputSchema.parse(mergedData) : mergedData; // Only trace if telemetry is available and action exists
            finalAction = action && _classPrivateFieldLooseBase(_this6, _telemetry)[_telemetry] ? _classPrivateFieldLooseBase(_this6, _telemetry)[_telemetry].traceMethod(action, {
              spanName: "workflow." + _this6.name + ".action." + stepId
            }) : action;
            if (!finalAction) {
              _context4.next = 14;
              break;
            }
            _context4.next = 11;
            return finalAction({
              data: validatedData,
              runId: runId
            });
          case 11:
            _context4.t0 = _context4.sent;
            _context4.next = 15;
            break;
          case 14:
            _context4.t0 = {};
          case 15:
            return _context4.abrupt("return", _context4.t0);
          case 16:
          case "end":
            return _context4.stop();
        }
      }, _callee4);
    }));
    return function handler(_x8) {
      return _ref22.apply(this, arguments);
    };
  }();
  // Only trace handler if telemetry is available
  var finalHandler = _classPrivateFieldLooseBase(this, _telemetry)[_telemetry] ? _classPrivateFieldLooseBase(this, _telemetry)[_telemetry].traceMethod(handler, {
    spanName: "workflow." + this.name + ".step." + stepId
  }) : handler;
  return {
    dependsOn: [],
    handler: finalHandler,
    data: {}
  };
}
function _makeDelayMap2() {
  var _this7 = this;
  var delayMap = {};
  _classPrivateFieldLooseBase(this, _steps)[_steps].forEach(function (step) {
    var _step$retryConfig2, _classPrivateFieldLoo2;
    delayMap[step.id] = (step == null || (_step$retryConfig2 = step.retryConfig) == null ? void 0 : _step$retryConfig2.delay) || ((_classPrivateFieldLoo2 = _classPrivateFieldLooseBase(_this7, _retryConfig)[_retryConfig]) == null ? void 0 : _classPrivateFieldLoo2.delay) || 1000;
  });
  return delayMap;
}
function _cleanup2() {
  if (_classPrivateFieldLooseBase(this, _actor)[_actor]) {
    _classPrivateFieldLooseBase(this, _actor)[_actor].stop();
    _classPrivateFieldLooseBase(this, _actor)[_actor] = null;
  }
}

var Step = function Step(_ref) {
  var id = _ref.id,
    action = _ref.action,
    payload = _ref.payload,
    outputSchema = _ref.outputSchema,
    inputSchema = _ref.inputSchema,
    retryConfig = _ref.retryConfig;
  this.id = void 0;
  this.inputSchema = void 0;
  this.outputSchema = void 0;
  this.payload = void 0;
  this.action = void 0;
  this.retryConfig = void 0;
  this.id = id;
  this.inputSchema = inputSchema;
  this.payload = payload;
  this.outputSchema = outputSchema;
  this.action = action;
  this.retryConfig = retryConfig;
};

/**
 * Abstract Memory class that defines the interface for storing and retrieving
 * conversation threads and messages.
 */
var MastraMemory = /*#__PURE__*/function () {
  function MastraMemory() {
    this.MAX_CONTEXT_TOKENS = void 0;
  }
  var _proto = MastraMemory.prototype;
  _proto.estimateTokens = function estimateTokens(text) {
    return Math.ceil(text.split(' ').length * 1.3);
  };
  _proto.parseMessages = function parseMessages(messages) {
    return messages.map(function (mssg) {
      return _extends({}, mssg, {
        content: typeof mssg.content === 'string' ? JSON.parse(mssg.content) : mssg.content
      });
    });
  };
  _proto.convertToUIMessages = function convertToUIMessages(messages) {
    function addToolMessageToChat(_ref) {
      var toolMessage = _ref.toolMessage,
        messages = _ref.messages,
        toolResultContents = _ref.toolResultContents;
      var chatMessages = messages.map(function (message) {
        if (message.toolInvocations) {
          return _extends({}, message, {
            toolInvocations: message.toolInvocations.map(function (toolInvocation) {
              var toolResult = toolMessage.content.find(function (tool) {
                return tool.toolCallId === toolInvocation.toolCallId;
              });
              if (toolResult) {
                return _extends({}, toolInvocation, {
                  state: 'result',
                  result: toolResult.result
                });
              }
              return toolInvocation;
            })
          });
        }
        return message;
      });
      var resultContents = [].concat(toolResultContents, toolMessage.content);
      return {
        chatMessages: chatMessages,
        toolResultContents: resultContents
      };
    }
    var _messages$reduce = messages.reduce(function (obj, message) {
        if (message.role === 'tool') {
          return addToolMessageToChat({
            toolMessage: message,
            messages: obj.chatMessages,
            toolResultContents: obj.toolResultContents
          });
        }
        var textContent = '';
        var toolInvocations = [];
        if (typeof message.content === 'string') {
          textContent = message.content;
        } else if (Array.isArray(message.content)) {
          var _loop = function _loop() {
            var content = _step.value;
            if (content.type === 'text') {
              textContent += content.text;
            } else if (content.type === 'tool-call') {
              var toolResult = obj.toolResultContents.find(function (tool) {
                return tool.toolCallId === content.toolCallId;
              });
              toolInvocations.push({
                state: toolResult ? 'result' : 'call',
                toolCallId: content.toolCallId,
                toolName: content.toolName,
                args: content.args,
                result: toolResult == null ? void 0 : toolResult.result
              });
            }
          };
          for (var _iterator = _createForOfIteratorHelperLoose(message.content), _step; !(_step = _iterator()).done;) {
            _loop();
          }
        }
        obj.chatMessages.push({
          id: message.id,
          role: message.role,
          content: textContent,
          toolInvocations: toolInvocations
        });
        return obj;
      }, {
        chatMessages: [],
        toolResultContents: []
      }),
      chatMessages = _messages$reduce.chatMessages;
    return chatMessages;
  }
  /**
   * Helper method to create a new thread
   * @param title - Optional title for the thread
   * @param metadata - Optional metadata for the thread
   * @returns Promise resolving to the created thread
   */;
  _proto.createThread =
  /*#__PURE__*/
  function () {
    var _createThread = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref2) {
      var threadId, resourceid, title, metadata, thread;
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            threadId = _ref2.threadId, resourceid = _ref2.resourceid, title = _ref2.title, metadata = _ref2.metadata;
            thread = {
              id: threadId || this.generateId(),
              title: title,
              resourceid: resourceid,
              createdAt: new Date(),
              updatedAt: new Date(),
              metadata: metadata
            };
            return _context.abrupt("return", this.saveThread({
              thread: thread
            }));
          case 3:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function createThread(_x) {
      return _createThread.apply(this, arguments);
    }
    return createThread;
  }()
  /**
   * Helper method to add a single message to a thread
   * @param threadId - The thread to add the message to
   * @param content - The message content
   * @param role - The role of the message sender
   * @param type - The type of the message
   * @param toolNames - Optional array of tool names that were called
   * @param toolCallArgs - Optional array of tool call arguments
   * @param toolCallIds - Optional array of tool call ids
   * @returns Promise resolving to the saved message
   */
  ;
  _proto.addMessage =
  /*#__PURE__*/
  function () {
    var _addMessage = /*#__PURE__*/_asyncToGenerator(/*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref3) {
      var threadId, content, role, type, toolNames, toolCallArgs, toolCallIds, message, savedMessages;
      return _regeneratorRuntime().wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            threadId = _ref3.threadId, content = _ref3.content, role = _ref3.role, type = _ref3.type, toolNames = _ref3.toolNames, toolCallArgs = _ref3.toolCallArgs, toolCallIds = _ref3.toolCallIds;
            message = {
              id: this.generateId(),
              content: content,
              role: role,
              createdAt: new Date(),
              threadId: threadId,
              type: type,
              toolNames: toolNames,
              toolCallArgs: toolCallArgs,
              toolCallIds: toolCallIds
            };
            _context2.next = 4;
            return this.saveMessages({
              messages: [message]
            });
          case 4:
            savedMessages = _context2.sent;
            return _context2.abrupt("return", savedMessages[0]);
          case 6:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function addMessage(_x2) {
      return _addMessage.apply(this, arguments);
    }
    return addMessage;
  }()
  /**
   * Generates a unique identifier
   * @returns A unique string ID
   */
  ;
  _proto.generateId = function generateId() {
    return crypto.randomUUID();
  };
  return MastraMemory;
}();

export { Agent, BaseLogger, ConsoleLogger, FileLogger, FilterOperators, InstrumentClass, Integration, LogLevel, Mastra, MastraEngine, MastraMemory, MastraVector, MultiLogger, PropertyType, RegisteredLogger, Step, Telemetry, UpstashRedisLogger, Workflow, createLogger, createMultiLogger, createSync, createTool, hasActiveTelemetry, withSpan };
//# sourceMappingURL=core.esm.js.map
